# FunctionMaps

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaApproximation.github.io/FunctionMaps.jl/dev)
[![Build Status](https://github.com/JuliaApproximation/FunctionMaps.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaApproximation/FunctionMaps.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaApproximation/FunctionMaps.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaApproximation/FunctionMaps.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

FunctionMaps.jl is a package designed to represent scalar- and vector-valued functions. It makes it easy to make new maps from existing ones, via composition or by taking products.

## Examples

For more information, see the [documentation](https://JuliaApproximation.github.io/FunctionMaps.jl/dev).

### Linear and affine maps

In comparison to existing packages with similar functionality, FunctionMaps aims to support non-invertible maps. These can be used to map between spaces of different dimension, such as from 2D to 3D. This leads to a linear map involving a rectangular matrix:
```julia
julia> using FunctionMaps

julia> m = LinearMap([0 0; 1 0; 0 1.0])
x -> A * x

A = 3×2 Matrix{Float64}:
 0.0  0.0
 1.0  0.0
 0.0  1.0

julia> m([1; 2])
3-element Vector{Float64}:
 0.0
 1.0
 2.0
```
This function `m` maps the 2D plane to the YZ-plane in a three-dimensional Euclidean space.

The map is not invertible on the full 3D space, but it is invertible on its range. In other words, it does have a left inverse from the YZ-plane back to 2D, which is again represented by a rectangular matrix:
```julia
julia> mi = leftinverse(m)
x -> A * x

A = 2×3 Matrix{Float64}:
 0.0  1.0  0.0
 0.0  0.0  1.0

julia> mi(m([1; 2]))
2-element Vector{Float64}:
 1.0
 2.0
```
The behaviour of the left inverse outside the image of the map is not defined in general, as indeed there may be multiple left inverses satisfying `mi(m(x)) == x`, but in this case it corresponds to a projection onto the YZ-plane.
```julia
julia> mi([1; 2; 3])
2-element Vector{Float64}:
 2.0
 3.0
```

### Domain and codomain type

Maps tend to be flexible in the type of the argument if the call makes sense mathematically. Yet, most maps do support one particular domain type. In that sense, in Julia terminology maps more closely resemble a method than a generic function.

Maps are functions of a single variable only. Functions of several variables can be represented as vector-valued maps. Such is the case in the current example.
```julia
julia> domaintype(m)
Vector{Float64} (alias for Array{Float64, 1})

julia> codomaintype(m)
Vector{Float64} (alias for Array{Float64, 1})
```


## Maps as an interface

The concrete maps defined in this package inherit from the abstract supertype `Map{T}`. Here, `T` is the domaintype and any instance conceptually represents a function `f(x::T)`. Like Julia functions and methods, the output is not explicitly typed.

A lot of the functionality in the package does not require maps to inherit from `Map{T}`, as long as they behave like maps. They should implement the following interface.

| Required methods | Brief description | Default behaviour |
| ---------------- | ----------------- | ----------------- |
| `applymap(m, x)` | Applies the map `m` to the argument `x` | `m(x)` |

Optional methods include:

| Important optional methods | Default definition | Brief description
| --- | --- | --- |
| `domaintype(m)` | `Any` | Returns a valid or intended type for arguments of the map |
| `codomaintype(m[, ::Type{T}])` | `Any` | The return type of the map (for arguments of type `T`) |


## History and development

The functionality in this package was originally developed as part of the [DomainSets.jl](https://github.com/JuliaApproximation/DomainSets.jl) package. It was extracted to allow more focused development and a better integration with existing packages with similar functionality.

"""
    MapStyle(m)

Trait to indicate whether or not `m` implements the map interface.
"""
abstract type MapStyle end

"""
    IsMap()

indicates an object implements the map interface.
"""
struct IsMap <: MapStyle end

"""
    NotMap()

indicates an object does not implement the Map interface.
"""
struct NotMap <: MapStyle end


MapStyle(m) = MapStyle(typeof(m))
# the default is no map
MapStyle(::Type) = NotMap()
# subtypes of Map are maps
MapStyle(::Type{<:Map}) = IsMap()

"""
    functionmap(m)

Return a map associated with the object `m`.

The result need not have type `Map`, but its `MapStyle` is `IsMap`.
"""
functionmap(m::Map) = m

"""
    MapRef(m)

A reference to a map.

In a function call, `MapRef(x)` can be used to indicate that `x` should be
treated as a map, e.g., `foo(x, MapRef(m))`.
"""
struct MapRef{M}
    map  ::  M
end

functionmap(m::MapRef) = m.map
domaintype(m::MapRef) = domaintype(functionmap(m))


"""
`AnyMap` is the union of `Map` and `MapRef`.

In both cases `map(m::AnyMap)` returns the map itself.
"""
const AnyMap = Union{Map,MapRef}

"""
   checkmap(m)

Checks that `m` is a map or refers to a map and if so returns that map,
throws an error otherwise.
"""
checkmap(m::Map) = m
# we trust the explicit intention of a user providing a map reference
checkmap(m::MapRef) = functionmap(m)
# for other objects we check MapStyle
checkmap(m) = _checkmap(m, MapStyle(m))
_checkmap(m, ::IsMap) = m
_checkmap(m, ::NotMap) =
    throw(ArgumentError("Map does not implement map interface as indicated by MapStyle."))

using FunctionMaps:
    convert_domaintype,
    convert_codomaintype,
    convert_numtype,
    convert_prectype,
    map_hash,
    LazyInverse, jacobian!,
    determinantmap,
    absmap,
    promote_maps,
    ScalarLinearMap,
    TypedMap

function generic_map_tests(T)
    for map in maps_to_test(T)
        @test prectype(map) == T
        test_generic_map(map)
    end
end

# generic map test suite
function test_generic_map(m)
    @test convert(Map{domaintype(m)}, m) == m

    x = suitable_point_to_map(m)
    @test applymap(m, x) == m(x)
    y = m(x)
    @test isrealmap(m) == (isreal(x) && isreal(y))

    S = domaintype(m)
    U = codomaintype(m)
    @test x isa S
    @test y isa U

    if isaffinemap(m) && !isconstantmap(m) && !(prectype(m) == BigFloat)
        test_generic_inverse(m)
    else
        try
            # The map may not support an inverse, let's try
            test_generic_inverse(m)
        catch e
            # make sure it failed because the inverse is not defined
            @test e isa MethodError || prectype(m) == BigFloat
        end
    end

    if isaffinemap(m)
        M = affinematrix(m)
        @test size(M) == mapsize(m)
        test_generic_jacobian(m)
    else
        try # jacobian may not be implemented
            test_generic_jacobian(m)
        catch e
        end
    end

    if domaintype(m) == Float64
        @test convert(Map{BigFloat}, m) isa Map{BigFloat}
        @test convert(Map{BigFloat}, m) == m
    end
    if prectype(m) == Float64
        U = widertype(domaintype(m))
        @test convert(Map{U}, m) isa Map{U}
        @test convert(Map{U}, m) == m
    end

    if isaffinemap(m)
        A = affinematrix(m)
        b = affinevector(m)
        @test m(x) == A*x+b
    end

    @test hash(m) == map_hash(m)
end

function test_generic_inverse(m)
    M = mapsize(m,1)
    N = mapsize(m,2)
    x = suitable_point_to_map(m)
    y = m(x)

    if M==N
        inverse(m, y)      # trigger exception outside test if not implemented

        minv = inverse(m)
        @test minv(y) ≈ x
        @test inverse(m)(y) ≈ x
        @test inverse(m, y) ≈ x
        @test m\y ≈ x
        @test LazyInverse(m)(y) ≈ inverse(m, y)
    end
    if M >= N && numtype(m)!=BigFloat
        leftinverse(m, y)      # trigger exception outside test if not implemented

        mli = leftinverse(m)
        @test mli(y) ≈ x
        @test leftinverse(m, y) ≈ x
    end
    if M <= N && numtype(m)!=BigFloat
        rightinverse(m, y)      # trigger exception outside test if not implemented

        mri = rightinverse(m)
        @test m(mri(y)) ≈ y
        @test m(rightinverse(m, y)) ≈ y
    end
end

function test_generic_jacobian(m)
    x = suitable_point_to_map(m)
    # Trigger exception outside of test if jacobian(m, x) is not implemented.
    # test_generic_jacobian(m) should be called within a try/catch block
    jacobian(m, x)

    δ = sqrt(eps(prectype(m)))
    x2 = x .+ δ
    # we intentionally test jacobian(m, x) before testing jacobian(m)
    if !(m isa ProductMap)
        @test norm(m(x2) - m(x) + jacobian(m, x)*(x-x2)) < 100δ
    end
    jac = jacobian(m)
    @test jac(x) ≈ jacobian(m, x)
    j = jacobian(m, x)
    @test size(j) == mapsize(m)
    if j isa AbstractArray{Float64}
        y = similar(j)
        jacobian!(y, m, x)
        @test y ≈ jac(x)
    end
    if issquarematrix(jac(x))
        @test jacdet(m, x) ≈ det(jacobian(m, x))
    end
    if mapsize(m) == ()
        d = diffvolume(m, x)
        s = sqrt(det(transpose(jacobian(m,x))*jacobian(m,x)))
        @test d ≈ s || d ≈ -s
    else
        @test abs(diffvolume(m, x) - sqrt(det(transpose(jacobian(m,x))*jacobian(m,x)))) < 1e-7
    end
    if isaffinemap(m)
        @test diffvolume(m) isa ConstantMap
    end
end

function test_generic_functionality_inverse()
    m = inverse(cos)
    @test m isa LazyInverse
    @test inverse(m) == cos
    @test !FunctionMaps.implements_inverse(cos)
    @test isequalmap(inverse(cos), inverse(cos))
end

function test_generic_functionality_jacobian()
    @test jacobian(cos) isa FunctionMaps.LazyJacobian
    m_jac = jacobian(cos)
    @test domaintype(m_jac) == Any
    @test_throws MethodError mapsize(m_jac)

    @test determinantmap(cos) isa FunctionMaps.DeterminantMap
    @test FunctionMaps.DeterminantMap{Float64}(LinearMap(2)) isa FunctionMaps.DeterminantMap{Float64}
    m_det = determinantmap(cos)
    @test domaintype(m_det) == Any
    @test m_det(4.0) == det(cos(4.0))

    @test absmap(cos) isa FunctionMaps.AbsMap
    @test FunctionMaps.AbsMap{Float64}(LinearMap(2)) isa FunctionMaps.AbsMap{Float64}
    m_abs = absmap(cos)
    @test domaintype(m_abs) == Any
    @test m_abs(4.0) == abs(cos(4.0))

    @test diffvolume(cos) isa FunctionMaps.LazyDiffVolume
    @test FunctionMaps.LazyDiffVolume{Float64}(LinearMap(2)) isa FunctionMaps.LazyDiffVolume{Float64}
    m_dvol = diffvolume(cos)
    @test_throws MethodError applymap(m_dvol, 2.0)
end


function test_generic_functionality()
    @test Map(cos) isa FunctionMaps.WrappedMap{Any}
    @test Map{Float64}(cos) isa FunctionMaps.WrappedMap{Float64}

    @test FunctionMaps.isvectorvalued_type(Float64)
    @test FunctionMaps.isvectorvalued_type(Vector{Float64})
    @test !FunctionMaps.isvectorvalued_type(Symbol)

    @test FunctionMaps.is_scalar_to_scalar(LinearMap(2))
    @test FunctionMaps.is_scalar_to_vector(LinearMap([2,2]))
    @test FunctionMaps.is_vector_to_vector(LinearMap(rand(2,2)))
    @test FunctionMaps.is_vector_to_scalar(ConstantMap{SVector{2,Float64}}(2))

    m_typed = ConstantMap(2)  # instance of subype of TypedMap
    @test domaintype(m_typed) == Int
    @test codomaintype(m_typed) == Int
    @test codomaintype(m_typed, Int) == Int
    @test codomaintype(m_typed, Any) == Int
    @test convert(TypedMap{Float64,Int}, m_typed) isa TypedMap{Float64,Int}
    @test convert(TypedMap{Int,Int}, m_typed) === m_typed

    m = LinearMap(2)
    @test convert_domaintype(Float64, m) isa ScalarLinearMap{Float64}
    @test convert_domaintype(Complex{Float64}, m) isa ScalarLinearMap{Complex{Float64}}
    @test convert_domaintype(SVector{2,BigFloat}, m) isa GenericLinearMap{SVector{2, BigFloat}, BigFloat}
    @test convert_domaintype(Any, m) === m
    @test convert_codomaintype(Float64, m) isa ScalarLinearMap{Float64}
    @test convert_codomaintype(Complex{Float64}, m) isa ScalarLinearMap{Complex{Float64}}
    @test_throws ArgumentError convert_codomaintype(SVector{2,BigFloat}, m)
    @test convert_domaintype(Any, cos) == cos
    @test domaintype(convert_domaintype(Float64, cos)) == Float64
    @test mapsize(m) == ()
    @test mapsize(m, 1) == 1
    @test mapsize(m, 2) == 1

    m2 = LinearMap{SVector{2,Float64}}(2)
    @test convert_domaintype(SVector{2,BigFloat}, m2) isa GenericLinearMap{SVector{2, BigFloat}, BigFloat}
    @test convert_codomaintype(SVector{2,BigFloat}, m2) isa GenericLinearMap{SVector{2, BigFloat}, BigFloat}
    @test mapsize(m2) == (2,2)
    @test mapsize(m2, 1) == 2
    @test mapsize(m2, 2) == 2

    m3 = LinearMap([1,2,3])
    @test mapsize(m3) == (3,)
    @test mapsize(m3, 1) == 3
    @test mapsize(m3, 2) == 1

    @test numtype(convert_numtype(Float64, LinearMap(2))) == Float64
    @test prectype(convert_prectype(Float64, LinearMap(2+im))) == Float64

    @test FunctionMaps.promote_map_point_pair(cos, 2) == (cos, 2)

    @test promote_maps() == ()
    @test promote_maps(cos) == cos
    @test FunctionMaps.promotable_maps(LinearMap(2), LinearMap(2.0))
    @test promote_maps(LinearMap(2), LinearMap(2.0)) isa Tuple{ScalarLinearMap{Float64}, ScalarLinearMap{Float64}}
    @test promote_maps(LinearMap(2), LinearMap(2.0), LinearMap(2.0)) isa Tuple{ScalarLinearMap{Float64}, ScalarLinearMap{Float64}, ScalarLinearMap{Float64}}

    A = LinearMap(rand(2,2))
    x = rand(2)
    y = zeros(2)
    @test FunctionMaps.applymap!(y, A, x) == A(x)
    @test y == A(x)

    test_generic_functionality_inverse()
    test_generic_functionality_jacobian()
end

using Test

using LinearAlgebra, StaticArrays
using CompositeTypes, CompositeTypes.Indexing

using FunctionMaps

include("aqua.jl")

include("test_common.jl")
include("test_interface.jl")

include("test_generic.jl")
include("test_basic.jl")
include("test_affine.jl")
include("test_canonical.jl")
include("test_product.jl")
include("test_composite.jl")

include("test_maps.jl")
include("test_arithmetics.jl")

function test_composite_maps()
    T = Float64
    a = T(0)
    b = T(1)
    c = T(2)
    d = T(3)
    ma = IdentityMap{T}()
    mb = interval_map(a, b, c, d)

    r = suitable_point_to_map(ma)
    m1 = ComposedMap(mb, ma)
    test_generic_map(m1)
    @test m1(r) ≈ ma(mb(r))
    m2 = ComposedMap(mb, m1)
    test_generic_map(m2)

    @test ncomponents(composedmap(m1,m1)) == 4

    m5 = ComposedMap(LinearMap(rand(T,2,2)), AffineMap(rand(T,2,2),rand(T,2)))
    test_generic_map(m5)
    @test jacobian(m5) isa ConstantMap
    @test m5[Component(1)] isa LinearMap
    @test m5[Component(2)] isa AffineMap
    @test ComposedMap(m5[Component(1:2)]...) == m5
    @test_throws BoundsError m5[Component(3)]

    m6 = multiply_map(ma,ma)
    @test m6(one(T)/2) == one(T)/4
    @test jacobian(m6) isa SumMap
    @test jacobian(m6)(one(T)) == 2
    @test jacobian(m6, one(T)) == 2

    m7 = sum_map(ma,ma)
    @test m7(one(T)) == 2
    @test jacobian(m7) isa ConstantMap
    @test jacobian(m7, one(T)) == 2
    @test sum_map() == ()
    @test sum_map(ma) == ma
    @test sum_map(ma, mb, ma) isa SumMap{T,Tuple{X,Y,Z}} where X where Y where Z
    @test sum_map(SumMap(ma, mb), ma) isa SumMap{T,Tuple{X,Y,Z}} where X where Y where Z
    @test sum_map(ma, SumMap(ma, mb)) isa SumMap{T,Tuple{X,Y,Z}} where X where Y where Z
    @test sum_map(SumMap(ma, mb), SumMap(ma,mb)) isa SumMap{T,Tuple{W,X,Y,Z}} where W where X where Y where Z
    @test FunctionMaps.SumMap{Float64}(LinearMap(2), LinearMap(2.0)) isa FunctionMaps.SumMap{Float64}
    @test allequal(map(domaintype,components(FunctionMaps.SumMap{Float64}(LinearMap(2), LinearMap(2.0)))))

    @test mapsize(ComposedMap(LinearMap(2),LinearMap(rand(T,2)),LinearMap(rand(T,2,2)))) == (2,)
    @test mapsize(ComposedMap(LinearMap(2),LinearMap(rand(T,2)))) == (2,)
    @test mapsize(ComposedMap(LinearMap(rand(T,2)),LinearMap(rand(T,2)'),LinearMap(rand(T,2)))) == (2,)
    @test mapsize(ComposedMap(LinearMap(rand(T,2,2)),LinearMap(rand(T,2)'),LinearMap(2))) == (1,2)
    @test mapsize(ComposedMap(LinearMap(one(T)),LinearMap(one(T)))) == ()

    @test composedmap() == ()
    @test composedmap(ma) == ma
    @test composedmap(ma,ma) == ma
    @test composedmap(ma,ma,ma) == ma

    @test composite_jacobian(ma) == jacobian(ma)

    @test multiply_map() == ()
    @test multiply_map(ma) == ma
    @test multiply_map(ma,ma)(2*one(T)) == 4
    @test multiply_map(ma,ma,ma)(2*one(T)) == 8
    @test FunctionMaps.mul_jacobian() == ()
    @test FunctionMaps.mul_jacobian(ma) == jacobian(ma)
    @test jacobian(multiply_map(ma, ma, ma)) isa FunctionMaps.SumMap
    
    @test ncomponents(multiply_map(multiply_map(ma,ma),multiply_map(ma,ma))) == 4
    @test multiply_map(LinearMap(2), LinearMap(2.0)) isa FunctionMaps.MulMap{Float64}
    @test FunctionMaps.MulMap{Float64}(LinearMap(2), LinearMap(2.0)) isa FunctionMaps.MulMap{Float64}
    @test allequal(map(domaintype,components(FunctionMaps.MulMap{Float64}(LinearMap(2), LinearMap(2.0)))))

    @test sum_jacobian() == ()
    @test sum_jacobian(ma) == jacobian(ma)

    @test convert_domaintype(Float64, ComposedMap(LinearMap(2), LinearMap(2))) isa Map{Float64}
    @test allequal(map(domaintype,components(convert_domaintype(Float64, ComposedMap(LinearMap(2), LinearMap(2))))))
end

"""
    LinearMap{T} <: AbstractAffineMap{T}

The supertype of all linear maps `y = A*x`.

Concrete subtypes may differ in how `A` is represented.
"""
abstract type LinearMap{T} <: AbstractAffineMap{T} end

mapsize(m::LinearMap) = _linearmap_size(m, domaintype(m), unsafe_matrix(m))
_linearmap_size(m, T, A) = size(A)
_linearmap_size(m, ::Type{T}, A::Number) where {T<:Number} = ()
_linearmap_size(m, ::Type{T}, A::AbstractVector) where {T<:Number} = (length(A),)
_linearmap_size(m, ::Type{T}, A::Number) where {N,T<:StaticVector{N}} = (N,N)

affinematrix(m::LinearMap) = to_matrix(domaintype(m), unsafe_matrix(m))
affinevector(m::LinearMap) = to_vector(domaintype(m), unsafe_matrix(m))

LinearMap(A::Number) = ScalarLinearMap(A)
LinearMap(A::SMatrix) = StaticLinearMap(A)
LinearMap(A::MMatrix) = StaticLinearMap(A)
LinearMap(A::Matrix) = VectorLinearMap(A)
LinearMap(A) = GenericLinearMap(A)

LinearMap{T}(A::Number) where {T<:Number} = _LinearMap(A, T, promote_type(T,typeof(A)))
_LinearMap(A::Number, ::Type{T}, ::Type{T}) where {T<:Number} = ScalarLinearMap{T}(A)
_LinearMap(A::Number, ::Type{T}, ::Type{S}) where {T<:Number,S} = GenericLinearMap{T}(A)
LinearMap{T}(A::SMatrix{M,N}) where {M,N,S,T <: SVector{N,S}} = StaticLinearMap{S}(A)
LinearMap{T}(A::MMatrix{M,N}) where {M,N,S,T <: SVector{N,S}} = StaticLinearMap{S}(A)
LinearMap{T}(A::Matrix) where {S,T <: Vector{S}} = VectorLinearMap{S}(A)
LinearMap{T}(A) where {T} = GenericLinearMap{T}(A)

# convenience functions
LinearMap(a::Number...) = LinearMap(promote(a...))
LinearMap(a::NTuple{N,T}) where {N,T <: Number} = LinearMap{SVector{N,T}}(Diagonal(SVector{N,T}(a)))

applymap(m::LinearMap, x) = _linear_applymap(m, x, unsafe_matrix(m))
_linear_applymap(m, x, A) = A*x

applymap!(y, m::LinearMap, x) = _linear_applymap!(y, m, x, unsafe_matrix(m))
_linear_applymap!(y, m, x, A) = mul!(y, A, x)

islinearmap(m::LinearMap) = true

isrealmap(m::LinearMap) = _linear_isrealmap(m, unsafe_matrix(m))
_linear_isrealmap(m, A) = isreal(A)

isequalmap(m1::LinearMap, m2::LinearMap) = affinematrix(m1) == affinematrix(m2)

# inverse should be called only on square maps, otherwise use
# leftinverse or rightinverse in order to use pinv instead of inv
inverse(m::LinearMap) = (@assert issquaremap(m); LinearMap(inv(m.A)))
inverse(m::LinearMap, x) = (@assert issquaremap(m); m.A \ x)

function leftinverse(m::LinearMap)
    @assert isoverdetermined(m)
    LinearMap(matrix_pinv(m.A))
end
function rightinverse(m::LinearMap)
    @assert isunderdetermined(m)
    LinearMap(matrix_pinv(m.A))
end
function leftinverse(m::LinearMap, x)
    @assert isoverdetermined(m)
    m.A \ x
end
function rightinverse(m::LinearMap, x)
    @assert isunderdetermined(m)
    m.A \ x
end

similarmap(m::LinearMap, ::Type{T}) where {T} = LinearMap{T}(m.A)

convert(::Type{Map}, a::Number) = LinearMap(a)
convert(::Type{Map{T}}, a::Number) where {T} = LinearMap{T}(a)

convert(::Type{LinearMap}, ::StaticIdentityMap{T}) where {T} = LinearMap{T}(1)
convert(::Type{LinearMap{T}}, ::StaticIdentityMap) where {T} = LinearMap{T}(1)
convert(::Type{AbstractAffineMap}, m::StaticIdentityMap) = convert(LinearMap, m)
convert(::Type{AbstractAffineMap{T}}, m::StaticIdentityMap) where {T} = convert(LinearMap, m)


map_stencil(m::LinearMap, x) = [unsafe_matrix(m), " * ", x]
map_stencil_broadcast(m::LinearMap, x) = _linear_map_stencil_broadcast(m, x, unsafe_matrix(m))
_linear_map_stencil_broadcast(m, x, A) = [A, " .* ", x]
_linear_map_stencil_broadcast(m, x, A::Number) = [A, " * ", x]


"A `GenericLinearMap` is a linear map `y = A*x` for any type of `A`."
struct GenericLinearMap{T,AA} <: LinearMap{T}
    A   ::  AA
end

"""
What is the suggested domaintype for a generic linear map `A*x` with
the given argument 'A'?
"""
glm_domaintype(A) = Any
glm_domaintype(A::Number) = typeof(A)
glm_domaintype(A::AbstractMatrix{T}) where T = Vector{T}
glm_domaintype(A::StaticMatrix{M,N,T}) where {M,N,T} = SVector{N,T}
glm_domaintype(A::AbstractVector{T}) where {T} = T
glm_domaintype(A::Diagonal{T,<:StaticVector{N,T}}) where {N,T} = SVector{N,T}

GenericLinearMap(A) = GenericLinearMap{glm_domaintype(A)}(A)

# Allow any A
GenericLinearMap{T}(A) where {T} = GenericLinearMap{T,typeof(A)}(A)

# Promote some eltypes if applicable
GenericLinearMap{T}(A::Number) where {T <: Number} =
    _GenericLinearMap(A, T, promote_type(T,typeof(A)))
_GenericLinearMap(A::Number, ::Type{T}, ::Type{T}) where {T <: Number} =
    GenericLinearMap{T,T}(A)
_GenericLinearMap(A::Number, ::Type{T}, ::Type{S}) where {S,T<:Number} =
    GenericLinearMap{T,typeof(A)}(A)

GenericLinearMap{T}(A::Number) where {T <: AbstractVector} =
    _GenericLinearMap(A, T, promote_type(eltype(T),typeof(A)))
_GenericLinearMap(A::Number, ::Type{T}, ::Type{S}) where {S,T<:AbstractVector{S}} =
    GenericLinearMap{T,S}(A)
_GenericLinearMap(A::Number, ::Type{T}, ::Type{S}) where {S,T<:AbstractVector} =
    GenericLinearMap{T,typeof(A)}(A)

GenericLinearMap{T}(A::AbstractMatrix{S}) where {S,T <: AbstractVector{S}} =
    GenericLinearMap{T,typeof(A)}(A)
GenericLinearMap{T}(A::AbstractMatrix{U}) where {S,T <: AbstractVector{S},U} =
    GenericLinearMap{T}(convert(AbstractMatrix{S}, A))
GenericLinearMap{T}(A::AbstractVector{T}) where {T} =
    GenericLinearMap{T,typeof(A)}(A)
GenericLinearMap{T}(A::AbstractVector{S}) where {S,T} =
    GenericLinearMap{T}(convert(AbstractVector{T}, A))
GenericLinearMap{T}(A::AbstractMatrix) where {T<:Number} =
    throw(ArgumentError("Linear map with matrix A can not have scalar domaintype."))

# Preserve the action on vectors with a number type
inverse(m::GenericLinearMap{T,AA}) where {T<:AbstractVector,AA<:Number} =
    LinearMap{T}(inv(m.A))
leftinverse(m::GenericLinearMap{T,AA}) where {T<:AbstractVector,AA<:Number} =
    LinearMap{T}(inv(m.A))
rightinverse(m::GenericLinearMap{T,AA}) where {T<:AbstractVector,AA<:Number} =
    LinearMap{T}(inv(m.A))

"A `ScalarLinearMap` is a linear map `y = A*x` for scalars."
struct ScalarLinearMap{T} <: LinearMap{T}
    A   ::  T
end

ScalarLinearMap(A::Number) = ScalarLinearMap{typeof(A)}(A)

isrealmap(m::ScalarLinearMap{T}) where {T} = isrealtype(T)

show(io::IO, m::ScalarLinearMap) = show_scalar_linear_map(io, m.A)
show_scalar_linear_map(io, A::Real) = print(io, "x -> $(A) * x")
show_scalar_linear_map(io, A::Complex) = print(io, "x -> ($(A)) * x")


"A `VectorLinearMap` is a linear map `y = A*x` using vectors and matrices."
struct VectorLinearMap{T} <: LinearMap{Vector{T}}
    A   ::  Matrix{T}
end

VectorLinearMap(A::AbstractMatrix{T}) where {T} =
    VectorLinearMap{T}(A)


"A `StaticLinearMap` is a linear map `y = A*x` using static arrays."
struct StaticLinearMap{T,N,M,L} <: LinearMap{SVector{N,T}}
    A   ::  SMatrix{M,N,T,L}
end

StaticLinearMap(A::AbstractMatrix{T}) where {T} =
    StaticLinearMap{T}(A)

StaticLinearMap{T}(A::StaticMatrix{M,N,S}) where {M,N,T,S} =
    StaticLinearMap{T}(convert(AbstractMatrix{T}, A))
StaticLinearMap{T}(A::StaticMatrix{M,N,T}) where {M,N,T} =
    StaticLinearMap{T,M,N}(A)
StaticLinearMap{T,N,M}(A::AbstractMatrix) where {T,N,M} =
    StaticLinearMap{T,N,M,M*N}(A)

convert(::Type{Map{SVector{N,T}}}, m::VectorLinearMap) where {N,T} = StaticLinearMap{T,N,N}(m.A)

# This file contains a few specific maps, included mainly to test
# functionality on non-trivial maps

"""
A Cartesion to Polar map. First dimension is interpreted as radial distance,
second as an angle.
The unit circle is mapped to the square `[-1,1]x[-1,1]`.
"""
struct CartToPolarMap{T} <: Map{SVector{2,T}}
end

CartToPolarMap() = CartToPolarMap{Float64}()

similarmap(::CartToPolarMap, ::Type{SVector{2,T}}) where {T<:Number} = CartToPolarMap{T}()
isequalmap(m1::CartToPolarMap, m2::CartToPolarMap) = true

mapsize(m::CartToPolarMap) = (2,2)

applymap(map::CartToPolarMap{T}, x) where {T} =
    SVector{2,T}(sqrt(x[1]^2+x[2]^2)*2-1, atan(x[2],x[1])/pi)

function jacobian(m::CartToPolarMap{T}, x) where {T}
    d = sqrt(x[1]^2+x[2]^2)
    r = 1/(1+(x[2]/x[1])^2)
    SMatrix{2,2,T}(2*x[1]/d, 1/pi*r*(-x[2]/x[1]^2), 2*x[2]/d, 1/pi*r*1/x[1])
end

inverse(m::CartToPolarMap{T}) where {T} = PolarToCartMap{T}()
inverse(m::CartToPolarMap, x) = inverse(m)(x)

isrealmap(m::CartToPolarMap) = true


"""
A Polar to Cartesian map. The angle is mapped to the second dimension,
radius to the first.
The square `[-1,1]x[-1,1]` is mapped to the unit circle.
"""
struct PolarToCartMap{T} <: Map{SVector{2,T}}
end

PolarToCartMap() = PolarToCartMap{Float64}()

similarmap(::PolarToCartMap, ::Type{SVector{2,T}}) where {T<:Number} = PolarToCartMap{T}()
isequalmap(m1::PolarToCartMap, m2::PolarToCartMap) = true

mapsize(m::PolarToCartMap) = (2,2)

applymap(map::PolarToCartMap{T}, x) where {T} = SVector{2,T}((x[1]+1)/2*cos(pi*x[2]), (x[1]+1)/2*sin(pi*x[2]))

jacobian(m::PolarToCartMap{T}, x) where {T} =
    SMatrix{2,2,T}(cos(pi*x[2])/2, sin(pi*x[2])/2, -pi*(x[1]+1)/2*sin(pi*x[2]), pi*(x[1]+1)/2*cos(pi*x[2]))

inverse(m::PolarToCartMap{T}) where {T} = CartToPolarMap{T}()
inverse(m::PolarToCartMap, x) = inverse(m)(x)

isrealmap(m::PolarToCartMap) = true


"""
The map `[cos(2πt), sin(2πt)]` from `[0,1]` to the unit circle in `ℝ^2`.
"""
struct UnitCircleMap{T} <: Map{T} end

UnitCircleMap() = UnitCircleMap{Float64}()

similarmap(::UnitCircleMap, ::Type{T}) where {T<:Number} = UnitCircleMap{T}()
isequalmap(::UnitCircleMap, ::UnitCircleMap) = true

mapsize(m::UnitCircleMap) = (2,)

applymap(m::UnitCircleMap{T}, t) where {T} = SVector(cos(2*T(pi)*t), sin(2*T(pi)*t))

function jacobian(m::UnitCircleMap{T}, t) where {T}
    a = 2*T(pi)
    SVector(-a*sin(a*t), a*cos(a*t))
end

# we know that the differential volume is 2*pi
diffvolume(m::UnitCircleMap{T}) where {T} = ConstantMap{T}(2*T(pi))

"""
`AngleMap` is a left inverse of `UnitCircleMap`. A 2D vector `x` is projected onto
the intersection point with the unit circle of the line connecting `x` to the
origin. The angle of this point, scaled to the interval `[0,1)`, is the result.
"""
struct AngleMap{T} <: Map{SVector{2,T}}
end

AngleMap() = AngleMap{Float64}()

similarmap(::AngleMap, ::Type{SVector{2,T}}) where {T<:Number} = AngleMap{T}()
isequalmap(::AngleMap, ::AngleMap) = true

function applymap(m::AngleMap{T}, x) where {T}
    twopi = 2*convert(T, pi)
    θ = atan(x[2],x[1])
    if θ < 0
        # atan2 returns an angle in (-π,π], convert to [0,2π) using periodicity.
        θ += twopi
    end
    # And divide by 2π to scale to [0,1)
    θ / twopi
end

mapsize(m::AngleMap) = (1,2)

function jacobian(m::AngleMap{T}, t) where {T}
    x = t[1]; y = t[2]
    twopi = 2*convert(T, pi)
    v = SVector(one(T) / (1+(y/x)^2) * (-y/x^2) * 1/twopi,
            one(T) / (1+(y/x)^2) * one(T)/x * 1/twopi)
    transpose(v)
end


leftinverse(m::UnitCircleMap{T}) where {T} = AngleMap{T}()
leftinverse(m::UnitCircleMap, x) = leftinverse(m)(x)
rightinverse(m::AngleMap{T}) where {T} = UnitCircleMap{T}()
rightinverse(m::AngleMap, x) = rightinverse(m)(x)


"""
The map `r*[cos(2πt), sin(2πt)]` from `[0,1]^2` to the unit disk in `ℝ^2`.
"""
struct UnitDiskMap{T} <: Map{SVector{2,T}} end

UnitDiskMap() = UnitDiskMap{Float64}()

similarmap(::UnitDiskMap, ::Type{SVector{2,T}}) where {T<:Number} = UnitDiskMap{T}()
isequalmap(::UnitDiskMap, ::UnitDiskMap) = true

mapsize(m::UnitDiskMap) = (2,2)

applymap(m::UnitDiskMap{T}, x) where {T} =
    SVector(x[1]*cos(2*T(pi)*x[2]), x[1]*sin(2*T(pi)*x[2]))

function jacobian(m::UnitDiskMap{T}, x) where {T}
    a = 2*T(pi)
    SMatrix{2,2}(cos(a*x[2]), sin(a*x[2]), -a*x[1]*sin(a*x[2]), a*x[1]*cos(a*x[2]))
end

# we know that the differential volume is 2*r*pi
diffvolume(m::UnitDiskMap, x) = 2*x[1]*pi

using FunctionMaps:
    MapStyle, IsMap, NotMap,
    functionmap, checkmap

struct MySimpleMap end
FunctionMaps.MapStyle(::Type{MySimpleMap}) = IsMap()

@testset "map interface" begin
    @test_throws ArgumentError checkmap((5,))   # a tuple is not a map
    @test MapStyle(2.0) isa IsMap
    @test MapStyle(2.0) == MapStyle(typeof(2.0))
    m = LinearMap(2)
    @test MapStyle(m) isa IsMap
    @test functionmap(m) === m
    @test checkmap(m) === m
    m2 = MySimpleMap()
    @test MapStyle(m2) isa IsMap
    @test checkmap(m2) == m2
end

"""
    AbstractAffineMap{T} <: Map{T}

An affine map has the general form `y = A*x + b`.

We use `affinematrix(m)` and `affinevector(m)` to denote `A` and `b`
respectively. Concrete subtypes include linear maps of the form `y = A*x`
and translations of the form `y = x + b`.

See also: [`affinematrix`](@ref), [`affinevector`](@ref).
"""
abstract type AbstractAffineMap{T} <: Map{T} end

unsafe_matrix(m::AbstractAffineMap) = m.A
unsafe_vector(m::AbstractAffineMap) = m.b

"Return the matrix `A` in the affine map `Ax+b`."
affinematrix(m::AbstractAffineMap) = to_matrix(domaintype(m), unsafe_matrix(m), unsafe_vector(m))

"Return the vector `b` in the affine map `Ax+b`."
affinevector(m::AbstractAffineMap) = to_vector(domaintype(m), unsafe_matrix(m), unsafe_vector(m))

applymap(m::AbstractAffineMap, x) = _affine_applymap(m, x, unsafe_matrix(m), unsafe_vector(m))
_affine_applymap(m, x, A, b) = A*x + b

applymap!(y, m::AbstractAffineMap, x) = _affine_applymap!(y, m, x, unsafe_matrix(m), unsafe_vector(m))
function _affine_applymap!(y, m, x, A, b)
    mul!(y, A, x)
    y .+= b
    y
end

isrealmap(m::AbstractAffineMap) = _affine_isrealmap(m, unsafe_matrix(m), unsafe_vector(m))
_affine_isrealmap(m, A, b) = isrealmap(A) && isreal(b)

jacobian(m::AbstractAffineMap{T}) where {T} = ConstantMap{T}(affinematrix(m))
jacobian(m::AbstractAffineMap, x) = affinematrix(m)

jacdet(m::AbstractAffineMap, x) = _affine_jacdet(m, x, unsafe_matrix(m))
_affine_jacdet(m, x, A) = det(A)
_affine_jacdet(m, x::Number, A::UniformScaling) = A.λ
_affine_jacdet(m, x::AbstractVector, A::Number) = A^length(x)
_affine_jacdet(m, x::AbstractVector, A::UniformScaling) = A.λ^length(x)

function diffvolume(m::AbstractAffineMap{T}) where T
    J = jacobian(m)
    c = sqrt(det(affinevector(J)'*affinevector(J)))
    ConstantMap{T}(c)
end

"""
    islinearmap(m)

Is `m` a linear map?
"""
islinearmap(m) = false
islinearmap(m::AbstractAffineMap) = _affine_islinearmap(m, unsafe_vector(m))
_affine_islinearmap(m, b) = all(b .== 0)

"""
    isaffinemap(m)

Is `m` an affine map?

If `m` is affine, then it has the form `m(x) = A*x+b`.

See also: [`affinematrix`](@ref), [`affinevector`](@ref).
"""
isaffinemap(m) = false
isaffinemap(m::Map) = islinearmap(m) || isconstantmap(m)
isaffinemap(m::AbstractAffineMap) = true

isequalmap(m1::AbstractAffineMap, m2::AbstractAffineMap) =
    affinematrix(m1) == affinematrix(m2) && affinevector(m1) == affinevector(m2)

isequalmap(m1::AbstractAffineMap, m2::IdentityMap) =
    islinearmap(m1) && affinematrix(m1) == affinematrix(m2)
isequalmap(m1::IdentityMap, m2::AbstractAffineMap) = isequalmap(m2, m1)

map_hash(m::AbstractAffineMap, h::UInt) = hashrec("AbstractAffineMap", affinematrix(m), affinevector(m), h)

mapsize(m::AbstractAffineMap) = _affine_mapsize(m, domaintype(m), unsafe_matrix(m), unsafe_vector(m))
_affine_mapsize(m, T, A::AbstractArray, b) = size(A)
_affine_mapsize(m, T, A::AbstractVector, b::AbstractVector) = (length(A),)
_affine_mapsize(m, T, A::Number, b::Number) = ()
_affine_mapsize(m, T, A::Number, b::AbstractVector) = (length(b),length(b))
_affine_mapsize(m, T, A::UniformScaling, b::Number) = ()
_affine_mapsize(m, T, A::UniformScaling, b) = (length(b),length(b))


Display.displaystencil(m::AbstractAffineMap) = vcat(["x -> "], map_stencil(m, 'x'))
show(io::IO, mime::MIME"text/plain", m::AbstractAffineMap) = composite_show(io, mime, m)

map_stencil(m::AbstractAffineMap, x) = _affine_map_stencil(m, x, unsafe_matrix(m), unsafe_vector(m))
_affine_map_stencil(m, x, A, b) = [A, " * ", x, " + ", b]
_affine_map_stencil(m, x, A, b::Real) =
    b >= 0 ? [A, " * ", x, " + ", b] :  [A, " * ", x, " - ", abs(b)]

map_stencil_broadcast(m::AbstractAffineMap, x) = _affine_map_stencil_broadcast(m, x, unsafe_matrix(m), unsafe_vector(m))
_affine_map_stencil_broadcast(m, x, A, b) = [A, " .* ", x, " .+ ", b]
_affine_map_stencil_broadcast(m, x, A::Number, b) = [A, " * ", x, " .+ ", b]

map_object_parentheses(m::AbstractAffineMap) = true
map_stencil_parentheses(m::AbstractAffineMap) = true

using FunctionMaps:
    hashrec,
    convert_numtype,
    promote_numtype,
    to_numtype,
    convert_prectype,
    promote_prectype,
    to_prectype,
    convert_eltype,
    euclideandimension,
    isrealtype

function test_hashrec()
    @test hashrec() == 0
    @test hashrec() isa UInt
    A = [1,2]
    @test hashrec(A) == hash(2, hash(1, hash((2,))))
    @test hashrec(1, 2) == hash(1, hash(2))
end

function test_dimension()
    @test euclideandimension(Int) == 1
    @test euclideandimension(Float64) == 1
    @test euclideandimension(ComplexF64) == 1
    @test euclideandimension(SVector{2,Float64}) == 2
    @test euclideandimension(MVector{2,Float64}) == 2
    @test euclideandimension(Tuple{Int,Int}) == 2
    @test euclideandimension(Tuple{Int,Float64}) == 2
    @test_throws ArgumentError euclideandimension(Vector{Float64})
end

function test_prectype()
    @test prectype(:some_symbol) == Any
    @test prectype(1.0) == Float64
    @test prectype(big(1.0)) == BigFloat
    @test prectype(1) == typeof(float(1))
    @test prectype(SVector(1,2)) == typeof(float(1))
    @test prectype(SVector(1,big(2))) == typeof(float(big(2)))
    @test prectype(1.0+2.0im) == Float64
    @test prectype([1.0+2.0im, 3.0]) == Float64
    @test prectype(NTuple{2,Int}) == Float64
    @test prectype(typeof((1.0,))) == Float64
    @test prectype(typeof((1.0, 2.0))) == Float64
    @test prectype(typeof((1.0, 2.0, 3.0))) == Float64
    @test prectype(typeof((1.0, big(2.0), 3.0+im))) == BigFloat
    @test prectype(NTuple{4,Int}) == Float64
    @test @inferred(prectype(1, 2.0)) == Float64
    @test @inferred(prectype(typeof((1, 2.0, 3, 40+im)))) == Float64

    @test convert_prectype(Float64, 2) == 2
    @test convert_prectype(Float64, 2) isa Float64
    @test convert_prectype(BigFloat, 1.0+im) == 1+im
    @test convert_prectype(BigFloat, 1.0+im) isa Complex{BigFloat}
    @test convert_prectype(Float64, SA[1,2]) == SA[1.0,2.0]
    @test convert_prectype(Float64, SA[1,2]) isa SVector{2,Float64}
    @test convert_prectype(Float64, MVector(1,2)) == MVector(1.0,2.0)
    @test convert_prectype(Float64, MVector(1,2)) isa MVector
    @test convert_prectype(Float64, SA[1 2; 3 4]) == SA[1.0 2.0; 3.0 4.0]
    @test convert_prectype(Float64, SA[1 2; 3 4]) isa SMatrix{2,2,Float64}
    @test convert_prectype(Float64, MMatrix{2,2}(1, 2, 3, 4)) == SA[1.0 3.0; 2.0 4.0]
    @test convert_prectype(Float64, MMatrix{2,2}(1, 2, 3, 4)) isa MMatrix{2,2,Float64}
    @test convert_prectype(BigFloat, SA[1,2+im]) isa SVector{2,Complex{BigFloat}}
    @test_throws ArgumentError convert_prectype(BigFloat, "a")

    @test promote_prectype(2) == 2
    @test promote_prectype(2, 3.0) isa Tuple{Float64,Float64}
    @test promote_prectype(2, 3.0+im, big(4)) isa Tuple{BigFloat,Complex{BigFloat},BigFloat}

    @test to_prectype(Float64, Int) === Float64
    @test to_prectype(Float32, Float64) === Float32
    @test to_prectype(Int, Int) === Int
    
    @test to_prectype(Float64, Complex{Int}) === Complex{Float64}
    @test to_prectype(Float32, Complex{Float64}) === Complex{Float32}
    @test to_prectype(Float64, Vector{Int}) === Vector{Float64}
    @test to_prectype(Float32, Vector{Float64}) === Vector{Float32}
    @test to_prectype(Float64, SVector{3,Int}) === SVector{3,Float64}
    @test to_prectype(Float32, MVector{3,Float64}) === MVector{3,Float32}
    @test to_prectype(Float64, SMatrix{2,2,Int}) === SMatrix{2,2,Float64}
    @test to_prectype(Float32, MMatrix{2,2,Float64}) === MMatrix{2,2,Float32}
    @test_throws ArgumentError to_prectype(Float64, String)
    @test_throws ArgumentError to_prectype(Float64, Dict{Int,Float64})    
end


function test_numtype()
    @test numtype(:some_symbol) == Any
    @test numtype(1.0) == Float64
    @test numtype(big(1.0)) == BigFloat
    @test numtype(1) == Int
    @test numtype([1,2,3], [4,5,6]) == Int
    @test numtype(SVector(1,2)) == Int
    @test numtype(SVector(1,big(2))) == BigInt
    @test numtype(Array{Float64,2}) == Float64
    @test numtype(1.0+2.0im) == Complex{Float64}
    @test numtype([1.0+2.0im, 3.0]) == Complex{Float64}
    @test numtype(NTuple{2,Complex{Int}}) == Complex{Int}
    @test numtype(typeof((1.0,))) == Float64
    @test numtype(typeof((1.0, 2.0))) == Float64
    @test numtype((1.0, 2.0, 3.0)) == Float64
    @test numtype((1.0, 2.0, 3.0, 4.0)) == Float64
    @test numtype(1.0, big(2.0), 3.0+im) == Complex{BigFloat}
    @test numtype(typeof((1.0, big(2.0), 3.0+im))) == Complex{BigFloat}
    @test numtype(Tuple{Int,Int,Int,Int,Float64}) == Float64
    @test @inferred(numtype(1, 2.0)) == Float64
    @test @inferred(numtype(typeof((1, 2.0, 3, 40+im)))) == Complex{Float64}

    @test convert_numtype(Float64, 2) == 2
    @test convert_numtype(Float64, 2) isa Float64
    @test convert_numtype(Float64, SA[1,2]) == SA[1.0,2.0]
    @test convert_numtype(Float64, SA[1,2]) isa SVector{2,Float64}
    @test convert_numtype(Float64, MVector(1,2)) == MVector(1.0,2.0)
    @test convert_numtype(Float64, MVector(1,2)) isa MVector
    @test convert_numtype(Float64, SA[1 2; 3 4]) == SA[1.0 2.0; 3.0 4.0]
    @test convert_numtype(Float64, SA[1 2; 3 4]) isa SMatrix{2,2,Float64}
    @test convert_numtype(Float64, MMatrix{2,2}(1, 2, 3, 4)) == SA[1.0 3.0; 2.0 4.0]
    @test convert_numtype(Float64, MMatrix{2,2}(1, 2, 3, 4)) isa MMatrix{2,2,Float64}
    @test_throws ArgumentError convert_numtype(BigFloat, "a")

    @test promote_numtype(2) == 2
    @test promote_numtype(2, 3.0) isa Tuple{Float64,Float64}
    @test promote_numtype(2, 3.0+im, big(4)) isa Tuple{Complex{BigFloat},Complex{BigFloat},Complex{BigFloat}}

    @test to_numtype(Float64, Int) === Float64
    @test to_numtype(Float32, Float64) === Float32
    @test to_numtype(Int, Int) === Int
    
    @test to_numtype(Float64, Vector{Int}) === Vector{Float64}
    @test to_numtype(Float32, Vector{Float64}) === Vector{Float32}
    @test to_numtype(Float64, SVector{3,Int}) === SVector{3,Float64}
    @test to_numtype(Float32, MVector{3,Float64}) === MVector{3,Float32}
    @test to_numtype(Float64, SMatrix{2,2,Int}) === SMatrix{2,2,Float64}
    @test to_numtype(Float32, MMatrix{2,2,Float64}) === MMatrix{2,2,Float32}
    @test_throws ArgumentError to_numtype(Float64, String)
    @test_throws ArgumentError to_numtype(Float64, Dict{Int,Float64})
end

function test_eltype()
    @test convert_eltype(Float64, Diagonal([1,2])) == Diagonal([1,2])
    @test eltype(convert_eltype(Float64, Diagonal([1,2]))) == Float64
    @test convert_eltype(Float64, 1:4) == 1:4
    @test eltype(convert_eltype(Float64, 1:4)) == Float64
    @test convert_eltype(Float64, Set([1,4])) == Set([1,4])
    @test eltype(convert_eltype(Float64, Set([1,4]))) == Float64
    @test convert_eltype(Float64, 5) == 5
    @test eltype(convert_eltype(Float64, 5)) == Float64

    @test FunctionMaps.promotable_eltypes(Int,Float64)
    @test FunctionMaps.promotable_eltypes(Vector{Int},Vector{Float64})
end

function test_realtype()
    @test isrealtype(Any) == false
    @test isrealtype(Int) == true
    @test isrealtype(ComplexF64) == false
    @test isrealtype(Matrix{Float64}) == true
end

@testset "common functionality" begin
    test_hashrec()
    test_dimension()
    test_prectype()
    test_numtype()
    test_eltype()
    test_realtype()
end

##############################
# Numbers and arrays as a map
##############################

# Arrays represent the linear map A*x
MapStyle(::Type{<:AbstractArray}) = IsMap()

Map(A::AbstractArray) = LinearMap(A)
Map{T}(A::AbstractArray) where T = LinearMap{T}(A)

domaintype(A::AbstractArray) = domaintype(Map(A))

applymap(A::AbstractArray, x) = A*x
mapsize(A::AbstractArray) = size(A)

islinearmap(A::AbstractArray) = true
isaffinemap(A::AbstractArray) = true
affinematrix(A::AbstractArray) = A
affinevector(A::AbstractArray) = zerovector(A)

inverse(A::AbstractMatrix) = inv(A)
inverse(A::AbstractMatrix, x) = A \ x

jacobian(A::AbstractMatrix) = ConstantMap{glm_domaintype(A)}(A)
jacobian(A::AbstractMatrix, x) = A

canonicalmap(A::AbstractArray) = Map(A)
canonicalmap(::Equal, A::AbstractArray) = Map(A)

# Numbers represent the linear map a*x

MapStyle(::Type{<:Number}) = IsMap()

applymap(a::Number, x) = a*x

Map(a::Number) = LinearMap(a)
Map{T}(a::Number) where T = LinearMap{T}(a)
domaintype(a::Number) = typeof(a)

mapsize(a::Number) = ()

islinearmap(a::Number) = true
isaffinemap(a::Number) = true
affinematrix(a::Number) = a
affinevector(a::Number) = zero(a)

inverse(a::Number) = inv(a)
inverse(a::Number, x) = a \ x

jacobian(a::Number) = ConstantMap(a)
jacobian(a::Number, x) = a

canonicalmap(a::Number) = Map(a)
canonicalmap(::Equal, a::Number) = Map(a)


###########################
# Uniform scaling as a map
###########################

MapStyle(::Type{<:UniformScaling}) = IsMap()

convert(::Type{Map}, A::UniformScaling) = GenericLinearMap{Vector{Any}}(A)
convert(::Type{Map{T}}, A::UniformScaling) where {T} = GenericLinearMap{T}(A)

# I(4) returns a diagonal matrix: the action of I is multiplication
applymap(I::UniformScaling, x) = I*x
domaintype(::UniformScaling{T}) where T = T
islinearmap(::UniformScaling) = true
affinematrix(I::UniformScaling) = I
affinevector(I::UniformScaling) = zerovector(I)

using FunctionMaps:
    hascanonicalmap,
    hasequalmap,
    equivalentmap,
    hasequivalentmap,
    tofunctionmap,
    equalmap

struct MyCanonicalType <: FunctionMaps.CanonicalType end

function test_canonical()
    m = LinearMap(2.0)
    @test canonicalmap(m) == m
    @test !hascanonicalmap(m)
    @test canonicalmap(MyCanonicalType(), m) == m
    @test !hascanonicalmap(MyCanonicalType(), m)

    @test tofunctionmap(m) == m
    @test tofunctionmap(MapRef(m)) == m

    @test canonicalmap(FunctionMaps.Equal(), 5.0) isa Map
    @test hasequalmap(5.0)
    @test equalmap(5.0) isa ScalarLinearMap{Float64}
    @test isequalmap(LinearMap(5), 5.0)

    m1 = LinearMap(2.0)
    m2tuple = FunctionMaps.TupleProductMap(m1, m1)
    @test hasequivalentmap(m2tuple)
    @test equivalentmap(m2tuple) isa FunctionMaps.VcatMap
end

# ensure that the domaintype of each map in the sequence agrees with the codomain type of the
# preceding map
function match_domain_codomain_types(::Type{T}, map, maps...) where {T}
    Y = promote_type(T, domaintype(map))
    m1 = convert_domaintype(Y, map)
    (m1, match_domain_codomain_types(codomaintype(m1), maps...)...)
end

match_domain_codomain_types(::Type{T}, map) where {T} = (convert_domaintype(T, map),)

"""
    ComposedMap{T,MAPS}

The composition of several maps.

The `components` of a `ComposedMap` are the maps in the order that they are applied
to the input.
"""
struct ComposedMap{T,MAPS} <: CompositeLazyMap{T}
    maps    ::  MAPS
end

function ComposedMap(map1, maps...)
    P = prectype(map1, maps...)
    if P == Any
        # don't try to promote types
        _ComposedMap(domaintype(map1), map1, maps...)
    else
        T = to_prectype(P, domaintype(map1))
        _ComposedMap(T, match_domain_codomain_types(T, map1, maps...)...)
    end
end
ComposedMap{T}(map1, maps...) where {T} = _ComposedMap(T, match_domain_codomain_types(T, map1, maps...)...)
_ComposedMap(::Type{T}, maps...) where {T} = ComposedMap{T,typeof(maps)}(maps)

similarmap(m::ComposedMap, ::Type{T}) where {T} = ComposedMap{T}(components(m)...)

codomaintype(m::ComposedMap) = codomaintype(last(m.maps))

# Maps are applied in the order that they appear in m.maps
applymap(m::ComposedMap, x) = applymap_rec(x, m.maps...)
applymap_rec(x) = x
applymap_rec(x, map1, maps...) = applymap_rec(applymap(map1, x), maps...)

# The size of a composite map depends on the first and the last map to be applied
# We check whether they are scalar_to_vector, vector_to_vector, etcetera
mapsize(m::ComposedMap) = _composed_mapsize(m, last(m.maps), first(m.maps), mapsize(last(m.maps)), mapsize(first(m.maps)))
_composed_mapsize(m, m_end, m1, S_end::Tuple{Int,Int}, S1::Tuple{Int,Int}) = (S_end[1],S1[2])
_composed_mapsize(m, m_end, m1, S_end::Tuple{Int,Int}, S1::Tuple{Int}) =
    is_vector_to_scalar(m_end) ? () : (S_end[1],)
_composed_mapsize(m, m_end, m1, S_end::Tuple{Int,Int}, S1::Tuple{}) =
    is_vector_to_scalar(m_end) ? () : (S_end[1],)
_composed_mapsize(m, m_end, m1, S_end::Tuple{Int}, S1::Tuple{Int,Int}) = (S_end[1],S1[2])
_composed_mapsize(m, m_end, m1, S_end::Tuple{Int}, S1::Tuple{Int}) = (S_end[1],)
_composed_mapsize(m, m_end, m1, S_end::Tuple{Int}, S1::Tuple{}) = (S_end[1],)
_composed_mapsize(m, m_end, m1, S_end::Tuple{}, S1::Tuple{Int,Int}) = (1,S1[2])
_composed_mapsize(m, m_end, m1, S_end::Tuple{}, S1::Tuple{Int}) = ()
_composed_mapsize(m, m_end, m1, S_end::Tuple{}, S1::Tuple{}) = ()

function jacobian(m::ComposedMap, x)
    f, fd = backpropagate(x, reverse(components(m))...)
    fd
end
backpropagate(x, m1) = (applymap(m1, x), jacobian(m1, x))
function backpropagate(x, m2, ms...)
    f, fd = backpropagate(x, ms...)
    applymap(m2, f), jacobian(m2, f) * fd
end

for op in (:inverse, :leftinverse, :rightinverse)
    @eval $op(cmap::ComposedMap) = ComposedMap(reverse(map($op, components(cmap)))...)
end

inverse(m::ComposedMap, x) = inverse_rec(x, reverse(components(m))...)
inverse_rec(x) = x
inverse_rec(x, map1, maps...) = inverse_rec(inverse(map1, x), maps...)

leftinverse(m::ComposedMap, x) = leftinverse_rec(x, reverse(components(m))...)
leftinverse_rec(x) = x
leftinverse_rec(x, map1, maps...) = leftinverse_rec(leftinverse(map1, x), maps...)

rightinverse(m::ComposedMap, x) = rightinverse_rec(x, reverse(components(m))...)
rightinverse_rec(x) = x
rightinverse_rec(x, map1, maps...) = rightinverse_rec(rightinverse(map1, x), maps...)


promote_composing_maps(m1, m2) =
    _promote_composing_maps(codomaintype(m1), domaintype(m2), m1, m2)
function _promote_composing_maps(::Type{S}, ::Type{T}, m1, m2) where {S,T}
    U = promote_type(S, T)
    convert_codomaintype(U, m1), convert_domaintype(U, m2)
end

composedmap() = ()
composedmap(m) = m
composedmap(m1, m2) = composedmap1(promote_composing_maps(m1, m2)...)
composedmap1(m1, m2) = composedmap2(m1, m2)
composedmap2(m1, m2) = default_composedmap(m1, m2)
default_composedmap(m1, m2) = ComposedMap(m1, m2)

composedmap(m1, m2, maps...) = composedmap(composedmap(m1, m2), maps...)

composedmap(m1::ComposedMap, m2::ComposedMap) =
    ComposedMap(components(m1)..., components(m2)...)
function composedmap1(m1::ComposedMap, m2)
    T = promote_type(codomaintype(m1), domaintype(m2))
    ComposedMap(components(m1)..., convert_domaintype(T, m2))
end
function composedmap2(m1, m2::ComposedMap)
    T = promote_type(codomaintype(m1), domaintype(m2))
    ComposedMap(convert_codomaintype(T, m1), components(m2)...)
end

# Arguments to ∘ should be reversed before passing on to mapcompose
Base.:∘(map1::Map, map2::Map) = composedmap(map2, map1)


isequalmap(m1::ComposedMap, m2::ComposedMap) =
    ncomponents(m1) == ncomponents(m2) && all(map(isequalmap, components(m1), components(m2)))
map_hash(m::ComposedMap, h::UInt) = hashrec("ComposedMap", collect(components(m)), h)

Display.combinationsymbol(m::ComposedMap) = Display.Symbol('∘')
Display.displaystencil(m::ComposedMap) =
    composite_displaystencil(m; reversecomponents=true)
map_object_parentheses(m::ComposedMap) = true
map_stencil_parentheses(m::ComposedMap) = true
show(io::IO, mime::MIME"text/plain", m::ComposedMap) = composite_show(io, mime, m)
show(io::IO, m::ComposedMap) = composite_show_compact(io, m)

## Lazy multiplication

"The lazy multiplication of one or more maps."
struct MulMap{T,MAPS} <: CompositeLazyMap{T}
    maps    ::  MAPS
end

MulMap(map1::Map, maps::Map...) = MulMap(promote_maps(map1, maps...)...)
MulMap(map1::Map{T}, maps::Map{T}...) where {T} = MulMap{T}(map1, maps...)
MulMap{T}(maps::Map{T}...) where {T} = MulMap{T,typeof(maps)}(maps)
MulMap{T}(maps...) where {T} = _mulmap(T, convert_domaintype.(Ref(T), maps)...)
_mulmap(::Type{T}, maps...) where {T} = MulMap{T,typeof(maps)}(maps)

similarmap(m::MulMap, ::Type{T}) where {T} = MulMap{T}(m.maps...)

applymap(m::MulMap, x) = reduce(*, applymap.(components(m), Ref(x)))

multiply_map() = ()
multiply_map(m) = m
multiply_map(m1, m2) = multiply_map1(m1, m2)
multiply_map1(m1, m2) = multiply_map2(m1, m2)
multiply_map2(m1, m2) = default_multiply_map(m1, m2)
default_multiply_map(m1, m2) = MulMap(m1, m2)

multiply_map(m1, m2, maps...) = multiply_map(multiply_map(m1, m2), maps...)

multiply_map(m1::MulMap, m2::MulMap) =
    MulMap(components(m1)..., components(m2)...)
multiply_map1(m1::MulMap, m2) = MulMap(components(m1)..., m2)
multiply_map2(m1, m2::MulMap) = MulMap(m1, components(m2)...)

function Display.displaystencil(m::MulMap)
    A = Any[]
    list = components(m)
    push!(A, "x -> ")
    push!(A, Display.SymbolObject(list[1]))
    push!(A, "(x)")
    for i in 2:length(list)
        push!(A, " * ")
        push!(A, Display.SymbolObject(list[i]))
        push!(A, "(x)")
    end
    A
end
show(io::IO, mime::MIME"text/plain", m::MulMap) = composite_show(io, mime, m)


## Lazy sum

"The lazy sum of one or more maps."
struct SumMap{T,MAPS} <: CompositeLazyMap{T}
    maps    ::  MAPS
end

SumMap(map1::Map, maps::Map...) = SumMap(promote_maps(map1, maps...)...)
SumMap(map1::Map{T}, maps::Map{T}...) where {T} = SumMap{T}(map1, maps...)
SumMap{T}(maps::Map{T}...) where {T} = SumMap{T,typeof(maps)}(maps)
SumMap{T}(maps...) where {T} = _summap(T, convert_domaintype.(Ref(T), maps)...)
_summap(::Type{T}, maps...) where {T} = SumMap{T,typeof(maps)}(maps)

similarmap(m::SumMap, ::Type{T}) where {T} = SumMap{T}(m.maps...)

applymap(m::SumMap, x) = reduce(+, applymap.(components(m), Ref(x)))

sum_map() = ()
sum_map(m) = m
sum_map(m1, m2) = sum_map1(m1, m2)
sum_map1(m1, m2) = sum_map2(m1, m2)
sum_map2(m1, m2) = default_sum_map(m1, m2)
default_sum_map(m1, m2) = SumMap(m1, m2)

sum_map(m1, m2, maps...) = sum_map(sum_map(m1, m2), maps...)

sum_map(m1::SumMap, m2::SumMap) =
    SumMap(components(m1)..., components(m2)...)
sum_map1(m1::SumMap, m2) = SumMap(components(m1)..., m2)
sum_map2(m1, m2::SumMap) = SumMap(m1, components(m2)...)

function Display.displaystencil(m::SumMap)
    A = Any[]
    list = components(m)
    push!(A, "x -> ")
    push!(A, Display.SymbolObject(list[1]))
    push!(A, "(x)")
    for i in 2:length(list)
        push!(A, " + ")
        push!(A, Display.SymbolObject(list[i]))
        push!(A, "(x)")
    end
    A
end
show(io::IO, mime::MIME"text/plain", m::SumMap) = composite_show(io, mime, m)


# Define the jacobian of a composite map
jacobian(m::ComposedMap) = composite_jacobian(reverse(components(m))...)
composite_jacobian(map1) = jacobian(map1)
composite_jacobian(map1, map2) = multiply_map(composedmap(map2, jacobian(map1)), jacobian(map2))
function composite_jacobian(map1, map2, maps...)
    rest = ComposedMap(reverse(maps)..., map2)
    f1 = composedmap(rest, jacobian(map1))
    f2 = composite_jacobian(map2, maps...)
    multiply_map(f1, f2)
end

jacobian(m::MulMap) = mul_jacobian(components(m)...)
mul_jacobian() = ()
mul_jacobian(map1) = jacobian(map1)
mul_jacobian(map1, map2) = sum_map(multiply_map(jacobian(map1), map2), multiply_map(map1, jacobian(map2)))
function mul_jacobian(map1, map2, maps...)
    rest = multiply_map(map2, maps...)
    mul_jacobian(map1, rest)
end
function jacobian(m::MulMap, x)
    z = map(t -> applymap(t,x), components(m))
    zd = map(t -> jacobian(t, x), components(m))
    sum(prod(z[1:i-1]) * zd[i] * prod(z[i+1:end]) for i in 1:ncomponents(m))
end


jacobian(m::SumMap) = sum_jacobian(components(m)...)
sum_jacobian() = ()
sum_jacobian(map1) = jacobian(map1)
sum_jacobian(maps...) = sum_map(map(jacobian, maps)...)

jacobian(m::SumMap, x) = sum(jacobian(mc, x) for mc in components(m))

using FunctionMaps
using Documenter

DocMeta.setdocmeta!(FunctionMaps, :DocTestSetup, :(using FunctionMaps); recursive=true)

makedocs(;
    modules=[FunctionMaps],
    authors="Daan Huybrechs <daan.huybrechs@kuleuven.be> and contributors",
    sitename="FunctionMaps.jl",
    format=Documenter.HTML(;
        edit_link="main",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
	    "Examples" => "examples.md",
        "API" => Any[
            "Public API Reference" => "api.md",
            "Internal API Reference" => "internal.md"
        ],
    ],
)

deploydocs(;
    repo="github.com/JuliaApproximation/FunctionMaps.jl.git", devbranch="main",
)

using FunctionMaps: ScalarAffineMap,
    VectorAffineMap,
    StaticAffineMap,
    GenericAffineMap,
    ScalarLinearMap,
    VectorLinearMap,
    StaticLinearMap,
    GenericLinearMap,
    ScalarTranslation,
    VectorTranslation,
    StaticTranslation,
    GenericTranslation,
    ProductMap,
    TupleProductMap, VcatMap, VectorProductMap,
    WrappedMap,
    interval_map, multiply_map,
    SumMap, sum_map,
    composedmap, ComposedMap,
    composite_jacobian, sum_jacobian,
    CartToPolarMap, PolarToCartMap,
    UnitCircleMap, AngleMap, UnitDiskMap,
    VectorToComplex


maps_to_test(T) = [
    IdentityMap{T}(),
    IdentityMap{Vector{T}}(10),
    ConstantMap{T}(one(T)),
    ConstantMap{T}(SVector{2,T}(1,2)),
    ZeroMap{T}(),
    UnityMap{T}(),
    AffineMap(T(1.2), T(2.4)), # scalar map
    AffineMap(-T(1.2), T(2.4)), # scalar map with negative A
    AffineMap(randvec(T, 2, 2), randvec(T, 2)), # static map
    AffineMap(randvec(T, 3, 2), randvec(T, 3)), # static map, rectangular
    AffineMap(rand(T, 2, 2), rand(T, 2)), # vector map
    AffineMap(rand(T, 3, 2), rand(T, 3)), # vector map, rectangular
    AffineMap(LinearAlgebra.I, one(T)/2),  # use UniformScaling object as A
    AffineMap(LinearAlgebra.I, randvec(T,2)),  # use UniformScaling object as A
    GenericAffineMap(randvec(T, 2, 2), randvec(T, 2)),
    GenericAffineMap(T(1.2), randvec(T, 2)),
    GenericAffineMap(randvec(T, 3, 2), randvec(T, 3)),
    Translation(randvec(T, 3)),
    LinearMap(randvec(T, 2, 2)),
    LinearMap(randvec(T, 2)),
    AffineMap(5.0, 2.0) ∘ VectorToComplex{T}() ∘ UnitCircleMap{T}(),
    LinearMap(SMatrix{2,2}(1,2,3,T(4))) ∘ CartToPolarMap{T}() ∘ LinearMap(SMatrix{2,2}(1,2,3,T(4))),
    # Interval{Any}(0.0, 1.0)
]

randvec(T,n) = SVector{n,T}(rand(n))
randvec(T,m,n) = SMatrix{m,n,T}(rand(m,n))

suitable_point_to_map(m::Map) = suitable_point_to_map(m, domaintype(m))

suitable_point_to_map(m::Map, ::Type{SVector{N,T}}) where {N,T} = SVector{N,T}(rand(N))
suitable_point_to_map(m::Map, ::Type{T}) where {T<:Number} = rand(T)
suitable_point_to_map(m::Map, ::Type{<:AbstractVector{T}}) where {T} = rand(T, mapsize(m,2))

suitable_point_to_map(m::ProductMap) =
    map(suitable_point_to_map, components(m))
suitable_point_to_map(m::VcatMap{T,M,N}) where {T,M,N} =
    SVector{N,T}(rand(T,N))

suitable_point_to_map(::CartToPolarMap{T}) where {T} = randvec(T,2)
suitable_point_to_map(::PolarToCartMap{T}) where {T} = randvec(T,2)

widertype(T) = widen(T)
widertype(::Type{SVector{N,T}}) where {N,T} = SVector{N,widen(T)}
widertype(::Type{Vector{T}}) where {T} = Vector{widen(T)}
widertype(::Type{Tuple{A}}) where {A} = Tuple{widen(A)}
widertype(::Type{Tuple{A,B}}) where {A,B} = Tuple{widen(A),widen(B)}
widertype(::Type{Tuple{A,B,C}}) where {A,B,C} = Tuple{widen(A),widen(B),widen(C)}
widertype(::Type{NTuple{N,T}}) where {N,T} = NTuple{N,widen(T)}

issquarematrix(A) = false
issquarematrix(A::AbstractArray) = size(A,1)==size(A,2)


function test_maps()
    @testset "generic functionality" begin
        test_generic_functionality()
        test_canonical()
    end

    @testset "generic map tests" begin
        generic_map_tests(Float64)
        generic_map_tests(BigFloat)
    end

    # Test special maps
    @testset "identity map" begin
        test_identity_map(Float64)
        test_identity_map(BigFloat)
    end
    @testset "basic maps" begin
        test_basic_maps(Float64)
        test_basic_maps(BigFloat)
    end
    @testset "affine maps" begin
        test_affine_maps(Float64)
        test_affine_maps(BigFloat)
    end
    @testset "composite maps" begin
        test_composite_maps()
    end
    @testset "product maps" begin
        test_product_map(Float64)
        test_product_map(BigFloat)
    end
    @testset "wrapped maps" begin
        test_wrapped_maps(Float64)
        test_wrapped_maps(BigFloat)
    end
    @testset "scaling maps" begin
        test_scaling_maps(Float64)
        test_scaling_maps(BigFloat)
    end
    @testset "isomorphisms" begin
        test_isomorphisms(Float64)
        test_isomorphisms(BigFloat)
    end
    @testset "Mixed maps" begin
        test_mixed_maps()
    end
end

function test_mixed_maps()
    m1 = composedmap(cos, sin)
    @test domaintype(m1) == Any
    @test m1(0.4) == sin(cos(0.4))

    m2 = composedmap(AffineMap(2.0, 3.0), cos)
    @test domaintype(m2) == Float64
    @test m2(0.4) ≈ cos(2*0.4+3)
    @inferred m2(0.4)
    @test repr(m2) == "cos ∘ (x -> 2.0 * x + 3.0)"

    m3 = composedmap(sin, AffineMap(2.0, 3.0), cos)
    @test m3(0.5) ≈ cos(2*sin(0.5)+3)
    @test repr(m3) == "cos ∘ (x -> 2.0 * x + 3.0) ∘ sin"
    @test domaintype(m3) == Any
    @inferred m3(0.5)

    m4 = productmap(sin, cos)
    @test m4 isa TupleProductMap
    @test domaintype(m4) == Tuple{Any,Any}
    @test m4(0.3,0.5) == (sin(0.3), cos(0.5))
end

test_maps()

using Aqua

# Aqua.test_all(FunctionMaps)

Aqua.test_ambiguities(FunctionMaps)
# The unbound tests annoyingly flag several valid uses of NTuple{N,T}
# Aqua.test_unbound_args(FunctionMaps)
Aqua.test_undefined_exports(FunctionMaps)
Aqua.test_project_extras(FunctionMaps)
Aqua.test_stale_deps(FunctionMaps)
Aqua.test_deps_compat(FunctionMaps)
# Piracies to be removed in next breaking release
Aqua.test_piracies(FunctionMaps)
Aqua.test_persistent_tasks(FunctionMaps)

"""
A `Map{T}` is a map of a single variable of type `T`.
"""
abstract type Map{T} end

Map(m) = convert(Map, m)
Map{T}(m) where {T} = convert(Map{T}, m)

"""
Any instance of `TypedMap{T,U}` maps a variable of type `T` to a variable
of type `U`.
"""
abstract type TypedMap{T,U} <: Map{T} end

const EuclideanMap{N,T} = Map{<:StaticVector{N,T}}
const VectorMap{T} = Map{Vector{T}}

CompositeTypes.Display.displaysymbol(m::Map) = 'F'

"""
    domaintype(m)

What is the expected type of a point in the domain of the function map `m`?
"""
domaintype(m) = domaintype(typeof(m))
domaintype(::Type{M}) where {M} = Any
domaintype(::Type{<:Map{T}}) where {T} = T

"""
    codomaintype(m[, T])

What is the type of a point in the codomain of the function map `m`?
    
The second argument optionally specifies a domain type `T`.
"""
codomaintype(m) = codomaintype(m, domaintype(m))
codomaintype(m, ::Type{T}) where {T} = _codomaintype(typeof(m), T)
_codomaintype(::Type{M}, ::Type{T}) where {M,T} = Base.promote_op(applymap, M, T)
_codomaintype(::Type{M}, ::Type{Any}) where {M} = Any
_codomaintype(::Type{<:TypedMap{T,U}}, ::Type{T}) where {T,U} = U
_codomaintype(::Type{<:TypedMap{T,U}}, ::Type{Any}) where {T,U} = U

prectype(::Type{<:Map{T}}) where T = prectype(T)
numtype(::Type{<:Map{T}}) where T = numtype(T)

"""
    isrealmap(m)

Is the map real-valued?

A map is real-valued if both its domain and codomain types are real.
"""
isrealmap(m) = isrealtype(domaintype(m)) && isrealtype(codomaintype(m))

convert(::Type{Map{T}}, m::Map{T}) where {T} = m
convert(::Type{Map{T}}, m::Map{S}) where {S,T} = similarmap(m, T)
convert(::Type{TypedMap{T,U}}, m::TypedMap{T,U}) where {T,U} = m
convert(::Type{TypedMap{T,U}}, m::TypedMap) where {T,U} = similarmap(m, T, U)

"""
    convert_domaintype(T, m)

Convert the given map to a map such that its `domaintype` is `T`.

See also: [`domaintype`](@ref).
"""
convert_domaintype(::Type{T}, map::Map{T}) where {T} = map
convert_domaintype(::Type{U}, map::Map{T}) where {T,U} = convert(Map{U}, map)
convert_domaintype(::Type{Any}, map) = map
convert_domaintype(::Type{Any}, map::Map{T}) where T = map
convert_domaintype(::Type{T}, map) where T = _convert_domaintype(T, map, domaintype(map))
_convert_domaintype(::Type{T}, map, ::Type{T}) where T = map
_convert_domaintype(::Type{U}, map, ::Type{T}) where {T,U} = Map{U}(map)

convert_numtype(::Type{U}, map::Map{T}) where {T,U} = convert(Map{to_numtype(U,T)}, map)
convert_prectype(::Type{U}, map::Map{T}) where {T,U} = convert(Map{to_prectype(U,T)}, map)

convert_codomaintype(::Type{U}, map) where U =
    _convert_codomaintype(U, map, domaintype(map), codomaintype(map))
# types match: we can return map
_convert_codomaintype(::Type{U}, map, ::Type{T}, ::Type{U}) where {T,U} = map
# ...or, outputs are vectors with the same eltype: that's good enough, further
# conversion might be unnecessary and expensive
_convert_codomaintype(::Type{<:AbstractVector{S}}, map, ::Type{T}, ::Type{<:AbstractVector{S}}) where {T,S} = map
# no match yet: we now try to convert the numtype
_convert_codomaintype(::Type{U}, map, ::Type{T}, ::Type{V}) where {T,U,V} =
    _convert_codomaintype2(U, convert_numtype(numtype(U), map))
_convert_codomaintype2(::Type{U}, map::Map) where U =
    _convert_codomaintype2(U, map, domaintype(map), codomaintype(map))
# better match this time around: we can return map
_convert_codomaintype2(::Type{U}, map, ::Type{T}, ::Type{U}) where {T,U} = map
_convert_codomaintype2(::Type{<:AbstractVector{S}}, map, ::Type{T}, ::Type{<:AbstractVector{S}}) where {T,S} = map
# still no match: we can't do this automatically
_convert_codomaintype2(::Type{U}, map, ::Type{T}, ::Type{V}) where {T,U,V} =
    throw(ArgumentError("Don't know how to convert the codomain type of $(map) to $(U)."))

convert_codomaintype(::Type{Any}, map) = map


# Users may call a map, concrete subtypes specialize the `applymap` function
# Some effort is spent at this generic level to convert the argument to something
# of type `T`.
(m::Map{T})(x) where {T} = promote_and_apply(m, x)
# For convenience we allow invocation with multiple arguments by conversion to T
(m::Map{T})(x...) where {T} = promote_and_apply(m, convert(T, x))

"Promote map and point to compatible types."
promote_map_point_pair(m, x) = (m, x)
promote_map_point_pair(m::Map, x) = _promote_map_point_pair(m, x, promote_type(domaintype(m), typeof(x)))
# This is the line where we promote both the map and the point:
_promote_map_point_pair(m, x, ::Type{T}) where {T} =
    convert(Map{T}, m), convert(T, x)
_promote_map_point_pair(m, x, ::Type{Any}) = m, x

# Some exceptions:
# - types match, do nothing
promote_map_point_pair(m::Map{T}, x::T) where {T} = m, x
# - an Any map, do nothing
promote_map_point_pair(m::Map{Any}, x) = m, x
# - tuples: these are typically composite maps, promotion may happen later
promote_map_point_pair(m::Map{<:Tuple}, x::Tuple) = m, x
# - abstract vectors: promotion may be expensive
promote_map_point_pair(m::Map{<:AbstractVector}, x::AbstractVector) = m, x
# - SVector: promotion is likely cheap
promote_map_point_pair(m::EuclideanMap{N,T}, x::AbstractVector{S}) where {N,S,T} =
    _promote_map_point_pair(m, x, SVector{N,promote_type(S,T)})

# For maps of type Map{T}, we call promote_map_point_pair and then applymap
promote_and_apply(m::Map, x) = applymap(promote_map_point_pair(m,x)...)

applymap!(y, m, x) = y .= m(x)

# Fallback for functions that are not of type Map
applymap(m, x) = m(x)


"Can the maps be promoted to a common domain type without throwing an error?"
promotable_maps(maps...) = promotable_eltypes(map(domaintype, maps)...)

"Promote the given maps to have a common domain type."
promote_maps() = ()
promote_maps(m1) = m1
function promote_maps(m1, m2)
    T = promote_type(domaintype(m1), domaintype(m2))
    convert_domaintype(T, m1), convert_domaintype(T, m2)
end
function promote_maps(m1, m2, m3, maps...)
    T = mapreduce(domaintype, promote_type, (m1,m2,m3,maps...))
    convert_domaintype.(T, (m1,m2,m3,maps...))
end

isvectorvalued_type(::Type{T}) where {T<:Number} = true
isvectorvalued_type(::Type{T}) where {T<:AbstractVector} = true
isvectorvalued_type(::Type{T}) where {T} = false


"Is the map a vector-valued function, i.e., a function from Rn to Rm?"
isvectorvalued(m) =
    isvectorvalued_type(domaintype(m)) && isvectorvalued_type(codomaintype(m))

"""
    mapsize(m[, i])

The size of a vectorvalued map is the size of its jacobian matrix.

A map with size (3,5) maps vectors of length 5 to vectors of length 3. Its jacobian matrix
is a 3-by-5 matrix.

Optionally, similar to the `size` function, a second argument `i` can be provided. Choose `i`
to be `1` or `2` to return only the corresponding element of the size. The dimension of the
domain type is `mapsize(m, 2)`, while that of the codomain type is `mapsize(m, 1)`.

If a map is scalar valued, its `mapsize` equals `()`. This reflects the convention in Julia that
the size of a number is an empty tuple: `size(5) == ()`. If a map is scalar-to-vector, its `mapsize`
is the tuple `(m,)` of length one. In this case the jacobian is a vector with size `(m,)`. If a map
is vector-to-scalar, its `mapsize` is `(1,n)`.

Thus, in all cases of scalarvalued and vectorvalued maps, the `mapsize` of a map agrees with the
size of the Jacobian matrix.
"""
function mapsize end

# mapsize should be defined for vector valued maps
# The size of a map equals the size of its jacobian
# The jacobian can be a number, a vector, an adjoint vector, or a matrix
mapsize(m, i) = _mapsize(m, i, mapsize(m))
_mapsize(m, i, size::Tuple{Int,Int}) = i <= 2 ? size[i] : 1
_mapsize(m, i, size::Tuple{Int}) = i <= 1 ? size[i] : 1
_mapsize(m, i, size::Tuple{}) = 1

"Is the given map a square map?"
issquaremap(m) = isvectorvalued(m) && (mapsize(m,1) == mapsize(m,2))

isoverdetermined(m) = mapsize(m,1) >= mapsize(m,2)
isunderdetermined(m) = mapsize(m,1) <= mapsize(m,2)

is_scalar_to_vector(m) = mapsize(m) isa Tuple{Int}
is_vector_to_scalar(m) = mapsize(m) isa Tuple{Int,Int} && codomaintype(m)<:Number
is_scalar_to_scalar(m) = mapsize(m) == ()
is_vector_to_vector(m) = mapsize(m) isa Tuple{Int,Int} && !is_vector_to_scalar(m)

# Display routines
map_stencil(m, x) = [Display.SymbolObject(m), '(', x, ')']
map_stencil_broadcast(m, x) = [Display.SymbolObject(m), ".(", x, ')']
map_stencil_broadcast(m::Function, x) = [repr(m), ".(", x, ')']

Display.object_parentheses(m::Map) = map_object_parentheses(m)
Display.stencil_parentheses(m::Map) = map_stencil_parentheses(m)

map_object_parentheses(m) = false
map_stencil_parentheses(m) = false

function test_isomorphisms(T)
    m1 = FunctionMaps.VectorToNumber{T}()
    @test m1(SA[1.0]) == 1.0
    m1b = FunctionMaps.NumberToVector{T}()
    @test inverse(m1) == m1b
    @test inverse(m1, 0.4) == m1b(0.4)
    @test inverse(m1b) == m1
    @test inverse(m1b, SA[0.4]) == m1(SA[0.4])
    @test m1b(1.0) == SA[1.0]
    @test mapsize(m1) == (1,1)
    @test mapsize(m1b) == (1,)
    @test mapsize(m1 ∘ inverse(m1)) == ()
    @test mapsize(inverse(m1) ∘ m1) == (1,1)
    @test jacobian(m1 ∘ inverse(m1), 1) == one(T)
    @test jacobian(inverse(m1) ∘ m1, [1]) == ones(T,1,1)
    @test jacobian(m1) isa ConstantMap
    @test jacobian(m1b) isa ConstantMap

    m2 = FunctionMaps.VectorToComplex{T}()
    @test m2(SA[one(T), one(T)]) == 1 + im
    m2b = FunctionMaps.ComplexToVector{T}()
    @test inverse(m2) == m2b
    @test inverse(m2, zero(T)+0im) == m2b(zero(T)+0im)
    @test inverse(m2b) == m2
    @test inverse(m2b, SA[one(T),one(T)]) == one(T)+one(T)*im
    @test m2b(one(T)+one(T)*im) == SA[one(T),one(T)]
    @test mapsize(m2) == (1,2)
    @test mapsize(m2b) == (2,)
    @test mapsize(m2 ∘ m2b) == ()
    @test mapsize(m2b ∘ m2) == (2,2)

    m3 = FunctionMaps.VectorToTuple{2,T}()
    m3b = FunctionMaps.TupleToVector{2,T}()
    @test m3(SA[one(T), one(T)]) == (one(T),one(T))
    @test inverse(m3b, SA[one(T), one(T)]) == (one(T),one(T))
    @test inverse(m3) == m3b
    @test inverse(m3b) == m3
    @test m3b( (one(T),one(T)) ) == SA[one(T),one(T)]
    @test inverse(m3, (one(T),one(T)) ) == SA[one(T),one(T)]

    m4 = FunctionMaps.NestedToFlat{3,T,Tuple{Tuple{T,T},T},(2,1)}()
    m4b = FunctionMaps.FlatToNested{3,T,Tuple{Tuple{T,T},T},(2,1)}()
    x4 = ([T(1),T(2)],T(3))
    y4 = T[1,2,3]
    @test m4(x4) == y4
    @test m4b(y4) == x4
    @test inverse(m4) == m4b
    @test inverse(m4b) == m4
    @test inverse(m4, y4) == x4
    @test inverse(m4b, x4) == y4
end

function test_scaling_maps(T)
    test_generic_map(LinearMap(T(2)))
    test_generic_map(LinearMap(T(2), T(3)))
    test_generic_map(LinearMap(T(2), T(3), T(4)))
    test_generic_map(LinearMap(T(2), T(3), T(4), T(5)))
end

function test_identity_map(T)
    i1 = IdentityMap{T}()
    @test i1 isa FunctionMaps.StaticIdentityMap
    i2 = IdentityMap{SVector{2,T}}()
    @test i2 isa FunctionMaps.StaticIdentityMap
    test_generic_map(i1)
    test_generic_map(i2)
    @test i1 == i2
    @test hash(i1) == hash(i2)
    @test islinearmap(i1)
    @test isaffinemap(i1)
    @test convert(FunctionMaps.StaticIdentityMap{SVector{2,T}}, i1) === i2
    @test jacobian(i1) isa ConstantMap
    @test jacobian(i1, 1) == 1
    @test jacdet(i1, 1) == 1
    m1 = convert(FunctionMaps.AbstractAffineMap{T}, i1)
    @test m1 isa LinearMap{T}
    @test jacdet(m1, 1) == 1
    @test convert(FunctionMaps.AbstractAffineMap, i1) isa LinearMap{T}
    m2 = convert(FunctionMaps.LinearMap{T}, i1)
    @test m2 isa LinearMap{T}
    @test jacdet(m2, 1) == 1

    i3 = IdentityMap{Vector{T}}(10)
    @test i3 isa FunctionMaps.VectorIdentityMap
    test_generic_map(i3)
    r = rand(T, 10)
    @test i3(r) ≈ r
    @test hash(i3) == hash(IdentityMap{Vector{Int}}(10))

    @test IdentityMap() ∘ LinearMap(2) == LinearMap(2.0)

    @test_throws ArgumentError IdentityMap{Float64}(10)
    @test_throws ArgumentError IdentityMap{Float64}(Val(2))
    @test IdentityMap{Float64}(1) isa Map
    @test IdentityMap{Float64}(Val(1)) isa Map
end

function test_basic_maps(T)
    @test UnityMap{SVector{2,Float64}}() == UnityMap{SVector{2,Float64},Float64}()
    @test hash(ConstantMap(2)) == hash(ConstantMap(2.0))
    @test FunctionMaps.absmap(ConstantMap(-2)) == ConstantMap(2)
end

function test_wrapped_maps(T)
    m1 = WrappedMap{T}(cos)
    m2 = WrappedMap{T}(sin)
    @test m1(one(T)) ≈ cos(one(T))
    @test m2(one(T)) ≈ sin(one(T))
    @test isequalmap(m1, cos)
    @test isequalmap(sin, m2)
    m3 = m1 ∘ m2
    @test m3(one(T)) ≈ cos(sin(one(T)))

    @test WrappedMap(cos) isa WrappedMap{Any}
    @test convert(Map, cos) isa WrappedMap
    @test convert(Map{BigFloat}, m1) isa WrappedMap{BigFloat}

    @test convert(Map{T}, cos) isa FunctionMaps.WrappedMap{T,typeof(cos)}

    @test convert(Map, LinearAlgebra.I) isa GenericLinearMap{Vector{Any}}
    @test convert(Map{Vector{T}}, LinearAlgebra.I) isa GenericLinearMap{Vector{T}}
end

"""
    AffineMap{T} <: AbstractAffineMap{T}

    The supertype of all affine maps that store `A` and `b`.
Concrete subtypes differ in how `A` and `b` are represented.
"""
abstract type AffineMap{T} <: AbstractAffineMap{T} end

"""
    AffineMap(A, b)

Return an affine map with an appropriate concrete type depending on the arguments
`A` and `b`.

# Examples
```julia
julia> AffineMap(2, 3)
x -> 2 * x + 3
```
"""
AffineMap(A::Number, b::Number) = ScalarAffineMap(A, b)
AffineMap(A::StaticMatrix, b::StaticVector) = StaticAffineMap(A, b)
AffineMap(A::Matrix, b::Vector) = VectorAffineMap(A, b)
AffineMap(A::UniformScaling{Bool}, b::Number) = ScalarAffineMap(one(b), b)
AffineMap(A, b) = GenericAffineMap(A, b)

AffineMap{T}(A::Number, b::Number) where {T<:Number} = ScalarAffineMap{T}(A, b)
AffineMap{T}(A::AbstractMatrix, b::AbstractVector) where {N,S,T<:SVector{N,S}} = StaticAffineMap{S,N}(A, b)
AffineMap{T}(A::Matrix, b::Vector) where {S,T<:Vector{S}} = VectorAffineMap{S}(A, b)
AffineMap{T}(A::UniformScaling{Bool}, b::Number) where {T} = ScalarAffineMap{T}(one(T), b)
AffineMap{T}(A, b) where {T} = GenericAffineMap{T}(A, b)

similarmap(m::AffineMap, ::Type{T}) where {T} = AffineMap{T}(m.A, m.b)

convert(::Type{AffineMap}, m) = (@assert isaffinemap(m); AffineMap(affinematrix(m), affinevector(m)))
convert(::Type{AffineMap{T}}, m) where {T} = (@assert isaffinemap(m); AffineMap{T}(affinematrix(m), affinevector(m)))
# avoid ambiguity errors with convert(::Type{T}, x::T) in Base:
convert(::Type{AffineMap}, m::AffineMap) = m
convert(::Type{AffineMap{T}}, m::AffineMap{T}) where T = m

# If y = A*x+b, then x = inv(A)*(y-b) = inv(A)*y - inv(A)*b
inverse(m::AffineMap) = (@assert issquaremap(m); AffineMap(inv(m.A), -inv(m.A)*m.b))
inverse(m::AffineMap, x) = (@assert issquaremap(m); m.A \ (x-m.b))

function leftinverse(m::AffineMap)
    @assert isoverdetermined(m)
    pA = matrix_pinv(m.A)
    AffineMap(pA, -pA*m.b)
end
function rightinverse(m::AffineMap)
    @assert isunderdetermined(m)
    pA = matrix_pinv(m.A)
    AffineMap(pA, -pA*m.b)
end
function leftinverse(m::AffineMap, x)
    @assert isoverdetermined(m)
    m.A \ (x-m.b)
end
function rightinverse(m::AffineMap, x)
    @assert isunderdetermined(m)
    m.A \ (x-m.b)
end


"An affine map for any combination of types of `A` and `b`."
struct GenericAffineMap{T,AA,B} <: AffineMap{T}
    A   ::  AA
    b   ::  B
end

GenericAffineMap(A, b) = GenericAffineMap{typeof(b)}(A, b)
GenericAffineMap(A::AbstractVector{S}, b::AbstractVector{T}) where {S,T} =
    GenericAffineMap{promote_type(S,T)}(A, b)
GenericAffineMap(A::AbstractArray{S}, b::AbstractVector{T}) where {S,T} =
    GenericAffineMap{Vector{promote_type(S,T)}}(A, b)
GenericAffineMap(A::StaticMatrix{M,N,S}, b::StaticVector{M,T}) where {M,N,S,T} =
    GenericAffineMap{SVector{N,promote_type(S,T)}}(A, b)
GenericAffineMap(A::StaticMatrix{M,N,S}, b::AbstractVector{T}) where {M,N,S,T} =
    GenericAffineMap{SVector{N,promote_type(S,T)}}(A, b)
GenericAffineMap(A::S, b::AbstractVector{T}) where {S<:Number,T} =
    GenericAffineMap{Vector{promote_type(S,T)}}(A, b)
GenericAffineMap(A::S, b::StaticVector{N,T}) where {S<:Number,N,T} =
    GenericAffineMap{SVector{N,promote_type(S,T)}}(A, b)
GenericAffineMap(A::UniformScaling{Bool}, b) =
    GenericAffineMap(UniformScaling{eltype(b)}(1), b)


# Fallback routine for generic A and b, special cases follow
GenericAffineMap{T}(A, b) where {T} = GenericAffineMap{T,typeof(A),typeof(b)}(A, b)

GenericAffineMap{T}(A::AbstractVector{S}, b::AbstractVector{U}) where {T<:Number,S,U} =
    GenericAffineMap{T}(convert(AbstractVector{T}, A), convert(AbstractVector{T}, b))
GenericAffineMap{T}(A::AbstractVector{T}, b::AbstractVector{T}) where {T<:Number} =
    GenericAffineMap{T,typeof(A),typeof(b)}(A, b)
GenericAffineMap{T}(A::Number, b) where {T} = GenericAffineMap{T,eltype(T),typeof(b)}(A, b)
GenericAffineMap{T}(A::Number, b::AbstractVector) where {N,S,T <: StaticVector{N,S}} =
    GenericAffineMap{T,S,SVector{N,S}}(A, b)
# Promote element types of abstract arrays
GenericAffineMap{T}(A::AbstractArray, b::AbstractVector) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T}(convert(AbstractArray{eltype(T)},A), convert(AbstractVector{eltype(T)}, b))
GenericAffineMap{T}(A::AbstractArray{S}, b::AbstractVector{S}) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T,typeof(A),typeof(b)}(A, b)
GenericAffineMap{T}(A::UniformScaling{Bool}, b::AbstractVector) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T}(A*one(S), convert(AbstractVector{S}, b))
GenericAffineMap{T}(A::UniformScaling{S}, b::AbstractVector{S}) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T,typeof(A),typeof(b)}(A, b)


similarmap(m::GenericAffineMap, ::Type{T}) where {T} = AffineMap{T}(m.A, m.b)

convert(::Type{GenericAffineMap{T}}, m::GenericAffineMap) where {T} =
    GenericAffineMap{T}(m.A, m.b)



"An affine map with scalar representation."
struct ScalarAffineMap{T} <: AffineMap{T}
    A   ::  T
    b   ::  T
end

ScalarAffineMap(A, b) = ScalarAffineMap(promote(A, b)...)

isrealmap(m::ScalarAffineMap{T}) where {T} = isrealtype(T)

show(io::IO, m::ScalarAffineMap) = show_scalar_affine_map(io, m.A, m.b)
show_scalar_affine_map(io, A::Real, b::Real) = print(io, "x -> $(A) * x", b < 0 ? " - " : " + ", abs(b))
show_scalar_affine_map(io, A::Complex, b::Complex) = print(io, "x -> ($(A)) * x + ", b)
show_scalar_affine_map(io, A, b) = print(io, "x -> ($(A)) * x + $(b)")


convert(::Type{ScalarAffineMap{T}}, m::ScalarAffineMap) where {T} =
    ScalarAffineMap{T}(m.A, m.b)

"An affine map with array and vector representation."
struct VectorAffineMap{T} <: AffineMap{Vector{T}}
    A   ::  Matrix{T}
    b   ::  Vector{T}
end

VectorAffineMap(A::AbstractArray{T}, b::AbstractVector{T}) where {T} =
    VectorAffineMap{T}(A, b)
function VectorAffineMap(A::AbstractArray{S}, b::AbstractVector{T}) where {S,T}
    U = promote_type(S,T)
    VectorAffineMap(convert(AbstractArray{U}, A), convert(AbstractVector{U}, b))
end

convert(::Type{VectorAffineMap{T}}, m::VectorAffineMap) where {T} =
    VectorAffineMap{T}(m.A, m.b)



"An affine map with representation using static arrays."
struct StaticAffineMap{T,N,M,L} <: AffineMap{SVector{N,T}}
    A   ::  SMatrix{M,N,T,L}
    b   ::  SVector{M,T}
end

# Constructors:
# - first, we deduce T
StaticAffineMap(A::AbstractMatrix{T}, b::AbstractVector{T}) where {T} =
    StaticAffineMap{T}(A, b)
function StaticAffineMap(A::AbstractMatrix{S}, b::AbstractVector{T}) where {S,T}
    U = promote_type(S,T)
    StaticAffineMap(convert(AbstractMatrix{U}, A), convert(AbstractVector{U}, b))
end

StaticAffineMap{T}(A::AbstractMatrix, b::AbstractVector) where {T} =
    StaticAffineMap{T}(convert(AbstractMatrix{T}, A), convert(AbstractVector{T}, b))

# - then, we determine N and/or M, from the arguments
function StaticAffineMap{T}(A::AbstractMatrix{T}, b::StaticVector{M,T}) where {T,M}
    @assert size(A) == (M,M)
    StaticAffineMap{T,M,M}(A, b)
end
StaticAffineMap{T}(A::StaticMatrix{M,N,T}, b::AbstractVector) where {T,N,M} =
    StaticAffineMap{T,N,M}(A, b)
StaticAffineMap{T}(A::StaticMatrix{M,N,T}, b::StaticVector{M,T}) where {T,N,M} =
    StaticAffineMap{T,N,M}(A, b)
# line below catches ambiguity error
StaticAffineMap{T}(A::StaticMatrix{M1,N,T}, b::StaticVector{M2,T}) where {T,N,M1,M2} =
    throw(ArgumentError("Non-matching dimensions"))
StaticAffineMap{T,N}(A::AbstractMatrix, b::AbstractVector) where {T,N} =
    StaticAffineMap{T,N,N}(A, b)
StaticAffineMap{T,N}(A::StaticMatrix{M,N}, b::AbstractVector) where {T,N,M} =
    StaticAffineMap{T,N,M}(A, b)

# - finally invoke the constructor (and implicitly convert the data if necessary)
StaticAffineMap{T,N,M}(A::AbstractMatrix, b::AbstractVector) where {T,N,M} =
    StaticAffineMap{T,N,M,M*N}(A, b)

convert(::Type{Map{SVector{N,T}}}, m::VectorAffineMap) where {N,T} =
    StaticAffineMap{T,N}(m.A, m.b)

module FunctionMaps

using CompositeTypes, CompositeTypes.Display, CompositeTypes.Indexing
using LinearAlgebra
using StaticArrays

import Base:
    convert, show,
    ==, hash        # for the equality of maps

import CompositeTypes: component, components

# Exhaustive list of exports:

# from CompositeTypes
export component, components, ncomponents

# from util/common.jl
export prectype, numtype

# from generic/map.jl
export Map, MapRef,
    applymap, isequalmap,
    domaintype, codomaintype,
    inverse, leftinverse, rightinverse,
    mapsize, jacobian, jacdet, diffvolume,
    isrealmap
# from generic/canonical.jl
export canonicalmap
# from generic/composite.jl
export composedmap
# from generic/product.jl
export ProductMap, productmap,
    factors, nfactors, factor

# from concrete/basic.jl
export IdentityMap,
    ZeroMap,
    UnityMap,
    ConstantMap,
    isconstantmap,
    mapconstant,
    isidentitymap
# from concrete/affine
export AffineMap, Translation, LinearMap,
    affinematrix, affinevector,
    islinearmap, isaffinemap

include("util/common.jl")

include("generic/map.jl")
include("generic/interface.jl")
include("generic/canonical.jl")
include("generic/lazy.jl")
include("generic/inverse.jl")
include("generic/jacobian.jl")
include("generic/composite.jl")
include("generic/product.jl")
include("generic/isomorphism.jl")
include("concrete/basic.jl")
include("concrete/affine/abstractaffine.jl")
include("concrete/affine/linear.jl")
include("concrete/affine/translation.jl")
include("concrete/affine/affine.jl")
include("concrete/affine/special.jl")
include("concrete/coordinates.jl")
include("concrete/arithmetics.jl")

end

"A `Translation` represents the map `y = x + b`."
abstract type Translation{T} <: AbstractAffineMap{T} end

# unsafe_matrix(m::Translation) = I
affinematrix(m::Translation) = to_matrix(domaintype(m), LinearAlgebra.I, unsafe_vector(m))
affinevector(m::Translation) = unsafe_vector(m)

mapsize(m::Translation) = _translation_mapsize(m, domaintype(m), unsafe_vector(m))
_translation_mapsize(m, ::Type{T}, b::Number) where {T} = ()
_translation_mapsize(m, ::Type{T}, b) where {T} = (length(b),length(b))

map_stencil(m::Translation, x) = _translation_map_stencil(m, x, unsafe_vector(m))
_translation_map_stencil(m, x, b) = [x, " + ", b]
_translation_map_stencil(m, x, b::Real) =
    b >= 0 ? [x, " + ", b] : [x, " - ", abs(b)]
map_stencil_broadcast(m::Translation, x) = _translation_map_stencil_broadcast(m, x, unsafe_vector(m))
_translation_map_stencil_broadcast(m, x, b) = [x, " .+ ", b]

"Translation by a scalar value."
struct ScalarTranslation{T} <: Translation{T}
    b   ::  T
end

isrealmap(m::ScalarTranslation{T}) where {T} = isrealtype(T)

show(io::IO, m::ScalarTranslation) = show_scalar_translation(io, m.b)
show_scalar_translation(io, b::Real) = print(io, "x -> x", b < 0 ? " - " : " + ", abs(b))
show_scalar_translation(io, b) = print(io, "x -> x + ", b)


"Translation by a static vector."
struct StaticTranslation{T,N} <: Translation{SVector{N,T}}
    b   ::  SVector{N,T}
end

"Translation by a vector."
struct VectorTranslation{T} <: Translation{Vector{T}}
    b   ::  Vector{T}
end

"Translation by a generic vectorlike object."
struct GenericTranslation{T,B} <: Translation{T}
    b   ::  B
end

Translation(b::Number) = ScalarTranslation(b)
Translation(b::StaticVector) = StaticTranslation(b)
Translation(b::Vector) = VectorTranslation(b)
Translation(b) = GenericTranslation(b)

Translation{T}(b::Number) where {T<:Number} = ScalarTranslation{T}(b)
Translation{T}(b::AbstractVector) where {N,S,T<:StaticVector{N,S}} = StaticTranslation{S,N}(b)
Translation{T}(b::Vector) where {S,T<:Vector{S}} = VectorTranslation{S}(b)
Translation{T}(b) where {T} = GenericTranslation{T}(b)

jacdet(m::Translation{T}) where {T} = UnityMap{T,eltype(T)}()
jacdet(m::Translation{T}, x) where {T} = one(eltype(T))

isrealmap(m::Translation) = isreal(unsafe_vector(m))

isequalmap(m1::Translation, m2::Translation) = unsafe_vector(m1)==unsafe_vector(m2)

similarmap(m::Translation, ::Type{T}) where {T} = Translation{T}(m.b)

applymap(m::Translation, x) = _translation_applymap(m, x, unsafe_vector(m))
_translation_applymap(m, x, b) = x + b
applymap!(y, m::Translation, x) = _translation_applymap!(y, m, x, unsafe_vector(m))
_translation_applymap!(y, m, x, b) = y .= x .+ m.b

inverse(m::Translation{T}) where {T} = Translation{T}(-m.b)
inverse(m::Translation, x) = x - m.b

ScalarTranslation(b::Number) = ScalarTranslation{typeof(b)}(b)

StaticTranslation(b::AbstractVector{T}) where {T} = StaticTranslation{T}(b)

StaticTranslation{T}(b::StaticVector{N}) where {N,T} =
    StaticTranslation{T,N}(b)

VectorTranslation(b::AbstractVector{T}) where {T} = VectorTranslation{T}(b)

GenericTranslation(b) = GenericTranslation{typeof(b)}(b)
GenericTranslation(b::AbstractVector{T}) where {T} =
    GenericTranslation{Vector{T}}(b)
GenericTranslation(b::StaticVector{N,T}) where {N,T} =
    GenericTranslation{SVector{N,T}}(b)

GenericTranslation{T}(b) where {T} = GenericTranslation{T,typeof(b)}(b)
GenericTranslation{T}(b::Number) where {T<:Number} =
    GenericTranslation{T,T}(b)

```@meta
CurrentModule = FunctionMaps
```

# FunctionMaps

This is the documentation for [FunctionMaps](https://github.com/JuliaApproximation/FunctionMaps.jl).

## What is FunctionMaps.jl

FunctionMaps.jl is a package designed to represent scalar- and vector-valued functions. It makes it easy to make new maps from existing ones, via composition or by taking products.

To get started, have a look at the examples or browse the API.

This documentation is a work in progress.

# Public API Reference

## Constants

```@autodocs
Modules = [FunctionMaps]
Order   = [:constant]
Public  = true
Private = false
```

## Functions

```@autodocs
Modules = [FunctionMaps]
Order   = [:function]
Public  = true
Private = false
```

## Types

```@autodocs
Modules = [FunctionMaps]
Order   = [:type]
Public  = true
Private = false
```
